/* AnimatedRenderer.c generated by valac 0.22.1, the Vala compiler
 * generated from AnimatedRenderer.vala, do not modify */

/**/
/*  Copyright (C) 2011 Robert Dyer*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>


#define PLANK_DRAWING_TYPE_ANIMATED_RENDERER (plank_drawing_animated_renderer_get_type ())
#define PLANK_DRAWING_ANIMATED_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_DRAWING_TYPE_ANIMATED_RENDERER, PlankDrawingAnimatedRenderer))
#define PLANK_DRAWING_ANIMATED_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_DRAWING_TYPE_ANIMATED_RENDERER, PlankDrawingAnimatedRendererClass))
#define PLANK_DRAWING_IS_ANIMATED_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_DRAWING_TYPE_ANIMATED_RENDERER))
#define PLANK_DRAWING_IS_ANIMATED_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_DRAWING_TYPE_ANIMATED_RENDERER))
#define PLANK_DRAWING_ANIMATED_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_DRAWING_TYPE_ANIMATED_RENDERER, PlankDrawingAnimatedRendererClass))

typedef struct _PlankDrawingAnimatedRenderer PlankDrawingAnimatedRenderer;
typedef struct _PlankDrawingAnimatedRendererClass PlankDrawingAnimatedRendererClass;
typedef struct _PlankDrawingAnimatedRendererPrivate PlankDrawingAnimatedRendererPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _PlankDrawingAnimatedRenderer {
	GObject parent_instance;
	PlankDrawingAnimatedRendererPrivate * priv;
};

struct _PlankDrawingAnimatedRendererClass {
	GObjectClass parent_class;
	gboolean (*animation_needed) (PlankDrawingAnimatedRenderer* self, GDateTime* render_time);
};

struct _PlankDrawingAnimatedRendererPrivate {
	GtkWidget* widget;
	guint animation_timer;
};


static gpointer plank_drawing_animated_renderer_parent_class = NULL;

GType plank_drawing_animated_renderer_get_type (void) G_GNUC_CONST;
#define PLANK_DRAWING_ANIMATED_RENDERER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PLANK_DRAWING_TYPE_ANIMATED_RENDERER, PlankDrawingAnimatedRendererPrivate))
enum  {
	PLANK_DRAWING_ANIMATED_RENDERER_DUMMY_PROPERTY
};
#define PLANK_DRAWING_ANIMATED_RENDERER_FPS ((guint) 60)
PlankDrawingAnimatedRenderer* plank_drawing_animated_renderer_construct (GType object_type);
PlankDrawingAnimatedRenderer* plank_drawing_animated_renderer_construct_with_widget (GType object_type, GtkWidget* widget);
void plank_drawing_animated_renderer_set_widget (PlankDrawingAnimatedRenderer* self, GtkWidget* widget);
gboolean plank_drawing_animated_renderer_animation_needed (PlankDrawingAnimatedRenderer* self, GDateTime* render_time);
static gboolean plank_drawing_animated_renderer_real_animation_needed (PlankDrawingAnimatedRenderer* self, GDateTime* render_time);
void plank_drawing_animated_renderer_animated_draw (PlankDrawingAnimatedRenderer* self);
static gboolean plank_drawing_animated_renderer_draw_timeout (PlankDrawingAnimatedRenderer* self);
static gboolean _plank_drawing_animated_renderer_draw_timeout_gsource_func (gpointer self);
static void plank_drawing_animated_renderer_finalize (GObject* obj);


/**
 * Creates a new animation renderer. Must call set_widget() later.
 */
PlankDrawingAnimatedRenderer* plank_drawing_animated_renderer_construct (GType object_type) {
	PlankDrawingAnimatedRenderer * self = NULL;
	self = (PlankDrawingAnimatedRenderer*) g_object_new (object_type, NULL);
	return self;
}


/**
 * Creates a new animation renderer for a widget.
 *
 * @param widget the widget to handle animations for
 */
PlankDrawingAnimatedRenderer* plank_drawing_animated_renderer_construct_with_widget (GType object_type, GtkWidget* widget) {
	PlankDrawingAnimatedRenderer * self = NULL;
	GtkWidget* _tmp0_ = NULL;
	g_return_val_if_fail (widget != NULL, NULL);
	self = (PlankDrawingAnimatedRenderer*) g_object_new (object_type, NULL);
	_tmp0_ = widget;
	plank_drawing_animated_renderer_set_widget (self, _tmp0_);
	return self;
}


/**
 * Sets the widget to handle animations for.
 *
 * @param widget the widget to handle animations for
 */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void plank_drawing_animated_renderer_set_widget (PlankDrawingAnimatedRenderer* self, GtkWidget* widget) {
	GtkWidget* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = widget;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->widget);
	self->priv->widget = _tmp1_;
}


/**
 * Determines if animation should continue.
 *
 * @param render_time the current time for this frame's render
 * @return if another animation frame is needed
 */
static gboolean plank_drawing_animated_renderer_real_animation_needed (PlankDrawingAnimatedRenderer* self, GDateTime* render_time) {
	g_critical ("Type `%s' does not implement abstract method `plank_drawing_animated_renderer_animation_needed'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean plank_drawing_animated_renderer_animation_needed (PlankDrawingAnimatedRenderer* self, GDateTime* render_time) {
	g_return_val_if_fail (self != NULL, FALSE);
	return PLANK_DRAWING_ANIMATED_RENDERER_GET_CLASS (self)->animation_needed (self, render_time);
}


/**
 * Request re-drawing.
 */
static gboolean _plank_drawing_animated_renderer_draw_timeout_gsource_func (gpointer self) {
	gboolean result;
	result = plank_drawing_animated_renderer_draw_timeout (self);
	return result;
}


void plank_drawing_animated_renderer_animated_draw (PlankDrawingAnimatedRenderer* self) {
	guint _tmp0_ = 0U;
	GtkWidget* _tmp1_ = NULL;
	GDateTime* _tmp2_ = NULL;
	GDateTime* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->animation_timer;
	if (_tmp0_ > ((guint) 0)) {
		return;
	}
	_tmp1_ = self->priv->widget;
	gtk_widget_queue_draw (_tmp1_);
	_tmp2_ = g_date_time_new_now_utc ();
	_tmp3_ = _tmp2_;
	_tmp4_ = plank_drawing_animated_renderer_animation_needed (self, _tmp3_);
	_tmp5_ = _tmp4_;
	_g_date_time_unref0 (_tmp3_);
	if (_tmp5_) {
		guint _tmp6_ = 0U;
		_tmp6_ = gdk_threads_add_timeout (1000 / PLANK_DRAWING_ANIMATED_RENDERER_FPS, _plank_drawing_animated_renderer_draw_timeout_gsource_func, self);
		self->priv->animation_timer = _tmp6_;
	}
}


static gboolean plank_drawing_animated_renderer_draw_timeout (PlankDrawingAnimatedRenderer* self) {
	gboolean result = FALSE;
	GtkWidget* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
	GDateTime* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	guint _tmp5_ = 0U;
	GtkWidget* _tmp7_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->widget;
	gtk_widget_queue_draw (_tmp0_);
	_tmp1_ = g_date_time_new_now_utc ();
	_tmp2_ = _tmp1_;
	_tmp3_ = plank_drawing_animated_renderer_animation_needed (self, _tmp2_);
	_tmp4_ = _tmp3_;
	_g_date_time_unref0 (_tmp2_);
	if (_tmp4_) {
		result = TRUE;
		return result;
	}
	_tmp5_ = self->priv->animation_timer;
	if (_tmp5_ > ((guint) 0)) {
		guint _tmp6_ = 0U;
		_tmp6_ = self->priv->animation_timer;
		g_source_remove (_tmp6_);
		self->priv->animation_timer = (guint) 0;
	}
	_tmp7_ = self->priv->widget;
	gtk_widget_queue_draw (_tmp7_);
	result = FALSE;
	return result;
}


static void plank_drawing_animated_renderer_class_init (PlankDrawingAnimatedRendererClass * klass) {
	plank_drawing_animated_renderer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PlankDrawingAnimatedRendererPrivate));
	PLANK_DRAWING_ANIMATED_RENDERER_CLASS (klass)->animation_needed = plank_drawing_animated_renderer_real_animation_needed;
	G_OBJECT_CLASS (klass)->finalize = plank_drawing_animated_renderer_finalize;
}


static void plank_drawing_animated_renderer_instance_init (PlankDrawingAnimatedRenderer * self) {
	self->priv = PLANK_DRAWING_ANIMATED_RENDERER_GET_PRIVATE (self);
	self->priv->animation_timer = (guint) 0;
}


static void plank_drawing_animated_renderer_finalize (GObject* obj) {
	PlankDrawingAnimatedRenderer * self;
	guint _tmp0_ = 0U;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_DRAWING_TYPE_ANIMATED_RENDERER, PlankDrawingAnimatedRenderer);
	_tmp0_ = self->priv->animation_timer;
	if (_tmp0_ > ((guint) 0)) {
		guint _tmp1_ = 0U;
		_tmp1_ = self->priv->animation_timer;
		g_source_remove (_tmp1_);
		self->priv->animation_timer = (guint) 0;
	}
	_g_object_unref0 (self->priv->widget);
	G_OBJECT_CLASS (plank_drawing_animated_renderer_parent_class)->finalize (obj);
}


/**
 * Handles animated rendering.  Uses a timer and continues requesting
 * redraws for a widget until no more animation is needed.
 */
GType plank_drawing_animated_renderer_get_type (void) {
	static volatile gsize plank_drawing_animated_renderer_type_id__volatile = 0;
	if (g_once_init_enter (&plank_drawing_animated_renderer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankDrawingAnimatedRendererClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_drawing_animated_renderer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDrawingAnimatedRenderer), 0, (GInstanceInitFunc) plank_drawing_animated_renderer_instance_init, NULL };
		GType plank_drawing_animated_renderer_type_id;
		plank_drawing_animated_renderer_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankDrawingAnimatedRenderer", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&plank_drawing_animated_renderer_type_id__volatile, plank_drawing_animated_renderer_type_id);
	}
	return plank_drawing_animated_renderer_type_id__volatile;
}



