/* DrawingService.c generated by valac 0.22.1, the Vala compiler
 * generated from DrawingService.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gee.h>
#include <gtk/gtk.h>


#define PLANK_DRAWING_TYPE_DRAWING_SERVICE (plank_drawing_drawing_service_get_type ())
#define PLANK_DRAWING_DRAWING_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_DRAWING_TYPE_DRAWING_SERVICE, PlankDrawingDrawingService))
#define PLANK_DRAWING_DRAWING_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_DRAWING_TYPE_DRAWING_SERVICE, PlankDrawingDrawingServiceClass))
#define PLANK_DRAWING_IS_DRAWING_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_DRAWING_TYPE_DRAWING_SERVICE))
#define PLANK_DRAWING_IS_DRAWING_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_DRAWING_TYPE_DRAWING_SERVICE))
#define PLANK_DRAWING_DRAWING_SERVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_DRAWING_TYPE_DRAWING_SERVICE, PlankDrawingDrawingServiceClass))

typedef struct _PlankDrawingDrawingService PlankDrawingDrawingService;
typedef struct _PlankDrawingDrawingServiceClass PlankDrawingDrawingServiceClass;
typedef struct _PlankDrawingDrawingServicePrivate PlankDrawingDrawingServicePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define PLANK_DRAWING_TYPE_COLOR (plank_drawing_color_get_type ())
typedef struct _PlankDrawingColor PlankDrawingColor;

struct _PlankDrawingDrawingService {
	GObject parent_instance;
	PlankDrawingDrawingServicePrivate * priv;
};

struct _PlankDrawingDrawingServiceClass {
	GObjectClass parent_class;
};

struct _PlankDrawingColor {
	gdouble R;
	gdouble G;
	gdouble B;
	gdouble A;
};


static gpointer plank_drawing_drawing_service_parent_class = NULL;

GType plank_drawing_drawing_service_get_type (void) G_GNUC_CONST;
enum  {
	PLANK_DRAWING_DRAWING_SERVICE_DUMMY_PROPERTY
};
#define PLANK_DRAWING_DRAWING_SERVICE_MISSING_ICONS "application-default-icon;;application-x-executable"
#define PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON "metadata::custom-icon"
#define PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME "metadata::custom-icon-name"
#define PLANK_DRAWING_DRAWING_SERVICE_SATURATION_WEIGHT 1.5
#define PLANK_DRAWING_DRAWING_SERVICE_WEIGHT_THRESHOLD 1.0
#define PLANK_DRAWING_DRAWING_SERVICE_ALPHA_THRESHOLD ((guint8) 24)
static PlankDrawingDrawingService* plank_drawing_drawing_service_new (void);
static PlankDrawingDrawingService* plank_drawing_drawing_service_construct (GType object_type);
gchar* plank_drawing_drawing_service_get_icon_from_file (GFile* file);
gchar* plank_drawing_drawing_service_get_icon_from_gicon (GIcon* icon);
GdkPixbuf* plank_drawing_drawing_service_load_icon (const gchar* names, gint width, gint height);
static gboolean plank_drawing_drawing_service_icon_is_file (const gchar* name);
static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf_from_file (const gchar* name, gint width, gint height);
static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf (const gchar* icon, gint size);
GdkPixbuf* plank_drawing_drawing_service_ar_scale (GdkPixbuf* source, gint width, gint height);
static GdkPixbuf* plank_drawing_drawing_service_get_empty_pixbuf (gint width, gint height);
GFile* plank_services_paths_get_HomeFolder (void);
GType plank_drawing_color_get_type (void) G_GNUC_CONST;
PlankDrawingColor* plank_drawing_color_dup (const PlankDrawingColor* self);
void plank_drawing_color_free (PlankDrawingColor* self);
void plank_drawing_drawing_service_average_color (GdkPixbuf* source, PlankDrawingColor* result);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static PlankDrawingDrawingService* plank_drawing_drawing_service_construct (GType object_type) {
	PlankDrawingDrawingService * self = NULL;
	self = (PlankDrawingDrawingService*) g_object_new (object_type, NULL);
	return self;
}


static PlankDrawingDrawingService* plank_drawing_drawing_service_new (void) {
	return plank_drawing_drawing_service_construct (PLANK_DRAWING_TYPE_DRAWING_SERVICE);
}


/**
 * Gets the icon name from a {@link GLib.File}.
 *
 * @param file the file to get the icon name for
 * @return the icon name for the file, or null if none exists
 */
gchar* plank_drawing_drawing_service_get_icon_from_file (GFile* file) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	{
		GFileInfo* info = NULL;
		GFile* _tmp0_ = NULL;
		GFileInfo* _tmp1_ = NULL;
		gchar* custom_icon_name = NULL;
		GFileInfo* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_ = NULL;
		gboolean _tmp8_ = FALSE;
		gchar* custom_icon = NULL;
		GFileInfo* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		gboolean _tmp12_ = FALSE;
		const gchar* _tmp13_ = NULL;
		gboolean _tmp15_ = FALSE;
		gchar* thumb_icon = NULL;
		GFileInfo* _tmp24_ = NULL;
		const gchar* _tmp25_ = NULL;
		gchar* _tmp26_ = NULL;
		gboolean _tmp27_ = FALSE;
		const gchar* _tmp28_ = NULL;
		gboolean _tmp30_ = FALSE;
		GFileInfo* _tmp31_ = NULL;
		GIcon* _tmp32_ = NULL;
		gchar* _tmp33_ = NULL;
		_tmp0_ = file;
		_tmp1_ = g_file_query_info (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_ICON "," PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME "," PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON "," G_FILE_ATTRIBUTE_THUMBNAIL_PATH, 0, NULL, &_inner_error_);
		info = _tmp1_;
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		_tmp2_ = info;
		_tmp3_ = g_file_info_get_attribute_string (_tmp2_, PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME);
		_tmp4_ = g_strdup (_tmp3_);
		custom_icon_name = _tmp4_;
		_tmp6_ = custom_icon_name;
		if (_tmp6_ != NULL) {
			const gchar* _tmp7_ = NULL;
			_tmp7_ = custom_icon_name;
			_tmp5_ = g_strcmp0 (_tmp7_, "") != 0;
		} else {
			_tmp5_ = FALSE;
		}
		_tmp8_ = _tmp5_;
		if (_tmp8_) {
			result = custom_icon_name;
			_g_object_unref0 (info);
			return result;
		}
		_tmp9_ = info;
		_tmp10_ = g_file_info_get_attribute_string (_tmp9_, PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON);
		_tmp11_ = g_strdup (_tmp10_);
		custom_icon = _tmp11_;
		_tmp13_ = custom_icon;
		if (_tmp13_ != NULL) {
			const gchar* _tmp14_ = NULL;
			_tmp14_ = custom_icon;
			_tmp12_ = g_strcmp0 (_tmp14_, "") != 0;
		} else {
			_tmp12_ = FALSE;
		}
		_tmp15_ = _tmp12_;
		if (_tmp15_) {
			const gchar* _tmp16_ = NULL;
			gboolean _tmp17_ = FALSE;
			GFile* _tmp18_ = NULL;
			const gchar* _tmp19_ = NULL;
			GFile* _tmp20_ = NULL;
			GFile* _tmp21_ = NULL;
			gchar* _tmp22_ = NULL;
			gchar* _tmp23_ = NULL;
			_tmp16_ = custom_icon;
			_tmp17_ = g_str_has_prefix (_tmp16_, "file://");
			if (_tmp17_) {
				result = custom_icon;
				_g_free0 (custom_icon_name);
				_g_object_unref0 (info);
				return result;
			}
			_tmp18_ = file;
			_tmp19_ = custom_icon;
			_tmp20_ = g_file_get_child (_tmp18_, _tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = g_file_get_path (_tmp21_);
			_tmp23_ = _tmp22_;
			_g_object_unref0 (_tmp21_);
			result = _tmp23_;
			_g_free0 (custom_icon);
			_g_free0 (custom_icon_name);
			_g_object_unref0 (info);
			return result;
		}
		_tmp24_ = info;
		_tmp25_ = g_file_info_get_attribute_byte_string (_tmp24_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH);
		_tmp26_ = g_strdup (_tmp25_);
		thumb_icon = _tmp26_;
		_tmp28_ = thumb_icon;
		if (_tmp28_ != NULL) {
			const gchar* _tmp29_ = NULL;
			_tmp29_ = thumb_icon;
			_tmp27_ = g_strcmp0 (_tmp29_, "") != 0;
		} else {
			_tmp27_ = FALSE;
		}
		_tmp30_ = _tmp27_;
		if (_tmp30_) {
			result = thumb_icon;
			_g_free0 (custom_icon);
			_g_free0 (custom_icon_name);
			_g_object_unref0 (info);
			return result;
		}
		_tmp31_ = info;
		_tmp32_ = g_file_info_get_icon (_tmp31_);
		_tmp33_ = plank_drawing_drawing_service_get_icon_from_gicon (_tmp32_);
		result = _tmp33_;
		_g_free0 (thumb_icon);
		_g_free0 (custom_icon);
		_g_free0 (custom_icon_name);
		_g_object_unref0 (info);
		return result;
	}
	goto __finally1;
	__catch1_g_error:
	{
		gchar* _tmp34_ = NULL;
		GFile* _tmp35_ = NULL;
		gchar* _tmp36_ = NULL;
		const gchar* _tmp37_ = NULL;
		const gchar* _tmp39_ = NULL;
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
		_tmp35_ = file;
		_tmp36_ = g_file_get_path (_tmp35_);
		_tmp34_ = _tmp36_;
		_tmp37_ = _tmp34_;
		if (_tmp37_ == NULL) {
			gchar* _tmp38_ = NULL;
			_tmp38_ = g_strdup ("");
			_g_free0 (_tmp34_);
			_tmp34_ = _tmp38_;
		}
		_tmp39_ = _tmp34_;
		g_debug ("DrawingService.vala:80: Could not get file info for '%s'", _tmp39_);
		_g_free0 (_tmp34_);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = NULL;
	return result;
}


/**
 * Gets an icon from a {@link GLib.Icon}.
 *
 * @param icon the icon to get the name for
 * @return the icon name, or null if none exists
 */
static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch2_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch2_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp5_;
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally2;
	__catch2_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar* plank_drawing_drawing_service_get_icon_from_gicon (GIcon* icon) {
	gchar* result = NULL;
	GIcon* _tmp0_ = NULL;
	GIcon* _tmp7_ = NULL;
	_tmp0_ = icon;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_themed_icon_get_type ())) {
		gchar* icons = NULL;
		GIcon* _tmp1_ = NULL;
		gchar** _tmp2_ = NULL;
		gchar** _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp1_ = icon;
		_tmp3_ = _tmp2_ = g_themed_icon_get_names (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_themed_icon_get_type (), GThemedIcon));
		_tmp4_ = g_strjoinv (";;", _tmp3_);
		icons = _tmp4_;
		_tmp5_ = icons;
		_tmp6_ = string_replace (_tmp5_, "(null);;", "");
		result = _tmp6_;
		_g_free0 (icons);
		return result;
	}
	_tmp7_ = icon;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, g_file_icon_get_type ())) {
		GIcon* _tmp8_ = NULL;
		GFile* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		_tmp8_ = icon;
		_tmp9_ = g_file_icon_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_file_icon_get_type (), GFileIcon));
		_tmp10_ = g_file_get_path (_tmp9_);
		result = _tmp10_;
		return result;
	}
	result = NULL;
	return result;
}


/**
 * Loads an icon based on names and the given width/height
 *
 * @param names a delimited (with ";;") list of icon names, first one found is used
 * @param width the requested width of the icon
 * @param height the requested height of the icon
 * @return the pixbuf representing the requested icon
 */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GdkPixbuf* plank_drawing_drawing_service_load_icon (const gchar* names, gint width, gint height) {
	GdkPixbuf* result = NULL;
	GeeArrayList* all_names = NULL;
	GeeArrayList* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gchar** _tmp7_ = NULL;
	gchar** _tmp8_ = NULL;
	GdkPixbuf* pbuf = NULL;
	GdkPixbuf* _tmp42_ = NULL;
	gint _tmp63_ = 0;
	gint _tmp64_ = 0;
	gint _tmp65_ = 0;
	gint _tmp66_ = 0;
	GdkPixbuf* _tmp67_ = NULL;
	g_return_val_if_fail (names != NULL, NULL);
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
	all_names = _tmp0_;
	_tmp1_ = names;
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, ";;", 0);
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = _tmp3_;
		s_collection_length1 = _vala_array_length (_tmp2_);
		for (s_it = 0; s_it < _vala_array_length (_tmp2_); s_it = s_it + 1) {
			gchar* _tmp4_ = NULL;
			gchar* s = NULL;
			_tmp4_ = g_strdup (s_collection[s_it]);
			s = _tmp4_;
			{
				GeeArrayList* _tmp5_ = NULL;
				const gchar* _tmp6_ = NULL;
				_tmp5_ = all_names;
				_tmp6_ = s;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
				_g_free0 (s);
			}
		}
		s_collection = (_vala_array_free (s_collection, s_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp8_ = _tmp7_ = g_strsplit (PLANK_DRAWING_DRAWING_SERVICE_MISSING_ICONS, ";;", 0);
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = _tmp8_;
		s_collection_length1 = _vala_array_length (_tmp7_);
		for (s_it = 0; s_it < _vala_array_length (_tmp7_); s_it = s_it + 1) {
			gchar* _tmp9_ = NULL;
			gchar* s = NULL;
			_tmp9_ = g_strdup (s_collection[s_it]);
			s = _tmp9_;
			{
				GeeArrayList* _tmp10_ = NULL;
				const gchar* _tmp11_ = NULL;
				_tmp10_ = all_names;
				_tmp11_ = s;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
				_g_free0 (s);
			}
		}
		s_collection = (_vala_array_free (s_collection, s_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	pbuf = NULL;
	{
		GeeArrayList* _name_list = NULL;
		GeeArrayList* _tmp12_ = NULL;
		GeeArrayList* _tmp13_ = NULL;
		gint _name_size = 0;
		GeeArrayList* _tmp14_ = NULL;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		gint _name_index = 0;
		_tmp12_ = all_names;
		_tmp13_ = _g_object_ref0 (_tmp12_);
		_name_list = _tmp13_;
		_tmp14_ = _name_list;
		_tmp15_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp14_);
		_tmp16_ = _tmp15_;
		_name_size = _tmp16_;
		_name_index = -1;
		while (TRUE) {
			gint _tmp17_ = 0;
			gint _tmp18_ = 0;
			gint _tmp19_ = 0;
			gchar* name = NULL;
			GeeArrayList* _tmp20_ = NULL;
			gint _tmp21_ = 0;
			gpointer _tmp22_ = NULL;
			const gchar* _tmp23_ = NULL;
			gboolean _tmp24_ = FALSE;
			const gchar* _tmp30_ = NULL;
			gint _tmp31_ = 0;
			gint _tmp32_ = 0;
			gint _tmp33_ = 0;
			GdkPixbuf* _tmp34_ = NULL;
			GdkPixbuf* _tmp35_ = NULL;
			const gchar* _tmp36_ = NULL;
			GeeArrayList* _tmp37_ = NULL;
			gpointer _tmp38_ = NULL;
			gchar* _tmp39_ = NULL;
			gboolean _tmp40_ = FALSE;
			_tmp17_ = _name_index;
			_name_index = _tmp17_ + 1;
			_tmp18_ = _name_index;
			_tmp19_ = _name_size;
			if (!(_tmp18_ < _tmp19_)) {
				break;
			}
			_tmp20_ = _name_list;
			_tmp21_ = _name_index;
			_tmp22_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, _tmp21_);
			name = (gchar*) _tmp22_;
			_tmp23_ = name;
			_tmp24_ = plank_drawing_drawing_service_icon_is_file (_tmp23_);
			if (_tmp24_) {
				const gchar* _tmp25_ = NULL;
				gint _tmp26_ = 0;
				gint _tmp27_ = 0;
				GdkPixbuf* _tmp28_ = NULL;
				GdkPixbuf* _tmp29_ = NULL;
				_tmp25_ = name;
				_tmp26_ = width;
				_tmp27_ = height;
				_tmp28_ = plank_drawing_drawing_service_load_pixbuf_from_file (_tmp25_, _tmp26_, _tmp27_);
				_g_object_unref0 (pbuf);
				pbuf = _tmp28_;
				_tmp29_ = pbuf;
				if (_tmp29_ != NULL) {
					_g_free0 (name);
					break;
				}
			}
			_tmp30_ = name;
			_tmp31_ = width;
			_tmp32_ = height;
			_tmp33_ = MAX (_tmp31_, _tmp32_);
			_tmp34_ = plank_drawing_drawing_service_load_pixbuf (_tmp30_, _tmp33_);
			_g_object_unref0 (pbuf);
			pbuf = _tmp34_;
			_tmp35_ = pbuf;
			if (_tmp35_ != NULL) {
				_g_free0 (name);
				break;
			}
			_tmp36_ = name;
			_tmp37_ = all_names;
			_tmp38_ = gee_list_last ((GeeList*) _tmp37_);
			_tmp39_ = (gchar*) _tmp38_;
			_tmp40_ = g_strcmp0 (_tmp36_, _tmp39_) != 0;
			_g_free0 (_tmp39_);
			if (_tmp40_) {
				const gchar* _tmp41_ = NULL;
				_tmp41_ = name;
				g_message ("DrawingService.vala:137: Could not find icon '%s'", _tmp41_);
			}
			_g_free0 (name);
		}
		_g_object_unref0 (_name_list);
	}
	_tmp42_ = pbuf;
	if (_tmp42_ != NULL) {
		gboolean _tmp43_ = FALSE;
		gboolean _tmp44_ = FALSE;
		gint _tmp45_ = 0;
		gboolean _tmp47_ = FALSE;
		gboolean _tmp58_ = FALSE;
		_tmp45_ = width;
		if (_tmp45_ != (-1)) {
			gint _tmp46_ = 0;
			_tmp46_ = height;
			_tmp44_ = _tmp46_ != (-1);
		} else {
			_tmp44_ = FALSE;
		}
		_tmp47_ = _tmp44_;
		if (_tmp47_) {
			gboolean _tmp48_ = FALSE;
			gint _tmp49_ = 0;
			GdkPixbuf* _tmp50_ = NULL;
			gint _tmp51_ = 0;
			gint _tmp52_ = 0;
			gboolean _tmp57_ = FALSE;
			_tmp49_ = width;
			_tmp50_ = pbuf;
			_tmp51_ = gdk_pixbuf_get_width (_tmp50_);
			_tmp52_ = _tmp51_;
			if (_tmp49_ != _tmp52_) {
				_tmp48_ = TRUE;
			} else {
				gint _tmp53_ = 0;
				GdkPixbuf* _tmp54_ = NULL;
				gint _tmp55_ = 0;
				gint _tmp56_ = 0;
				_tmp53_ = height;
				_tmp54_ = pbuf;
				_tmp55_ = gdk_pixbuf_get_height (_tmp54_);
				_tmp56_ = _tmp55_;
				_tmp48_ = _tmp53_ != _tmp56_;
			}
			_tmp57_ = _tmp48_;
			_tmp43_ = _tmp57_;
		} else {
			_tmp43_ = FALSE;
		}
		_tmp58_ = _tmp43_;
		if (_tmp58_) {
			GdkPixbuf* _tmp59_ = NULL;
			gint _tmp60_ = 0;
			gint _tmp61_ = 0;
			GdkPixbuf* _tmp62_ = NULL;
			_tmp59_ = pbuf;
			_tmp60_ = width;
			_tmp61_ = height;
			_tmp62_ = plank_drawing_drawing_service_ar_scale (_tmp59_, _tmp60_, _tmp61_);
			result = _tmp62_;
			_g_object_unref0 (pbuf);
			_g_object_unref0 (all_names);
			return result;
		}
		result = pbuf;
		_g_object_unref0 (all_names);
		return result;
	}
	g_warning ("DrawingService.vala:146: No icon found, return empty pixbuf");
	_tmp63_ = width;
	_tmp64_ = MAX (1, _tmp63_);
	_tmp65_ = height;
	_tmp66_ = MAX (1, _tmp65_);
	_tmp67_ = plank_drawing_drawing_service_get_empty_pixbuf (_tmp64_, _tmp66_);
	result = _tmp67_;
	_g_object_unref0 (pbuf);
	_g_object_unref0 (all_names);
	return result;
}


static GdkPixbuf* plank_drawing_drawing_service_get_empty_pixbuf (gint width, gint height) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GdkPixbuf* _tmp2_ = NULL;
	_tmp0_ = width;
	_tmp1_ = height;
	_tmp2_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, _tmp0_, _tmp1_);
	pbuf = _tmp2_;
	gdk_pixbuf_fill (pbuf, (guint32) 0x00000000);
	result = pbuf;
	return result;
}


static gboolean plank_drawing_drawing_service_icon_is_file (const gchar* name) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp11_ = FALSE;
	g_return_val_if_fail (name != NULL, FALSE);
	_tmp2_ = name;
	_tmp3_ = g_str_has_prefix (_tmp2_, "/");
	if (_tmp3_) {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
		_tmp4_ = name;
		_tmp5_ = g_str_has_prefix (_tmp4_, "~/");
		_tmp1_ = _tmp5_;
	}
	_tmp6_ = _tmp1_;
	if (_tmp6_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
		_tmp7_ = name;
		_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) (-1));
		_tmp9_ = _tmp8_;
		_tmp10_ = g_str_has_prefix (_tmp9_, "file://");
		_tmp0_ = _tmp10_;
		_g_free0 (_tmp9_);
	}
	_tmp11_ = _tmp0_;
	result = _tmp11_;
	return result;
}


static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf_from_file (const gchar* name, gint width, gint height) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	gchar* filename = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	pbuf = NULL;
	_tmp0_ = name;
	_tmp1_ = g_strdup (_tmp0_);
	filename = _tmp1_;
	_tmp2_ = name;
	_tmp3_ = g_str_has_prefix (_tmp2_, "~/");
	if (_tmp3_) {
		gchar* _tmp4_ = NULL;
		GFile* _tmp5_ = NULL;
		GFile* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		const gchar* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		_tmp5_ = plank_services_paths_get_HomeFolder ();
		_tmp6_ = _tmp5_;
		_tmp7_ = g_file_get_path (_tmp6_);
		_tmp4_ = _tmp7_;
		_tmp8_ = _tmp4_;
		if (_tmp8_ == NULL) {
			gchar* _tmp9_ = NULL;
			_tmp9_ = g_strdup ("");
			_g_free0 (_tmp4_);
			_tmp4_ = _tmp9_;
		}
		_tmp10_ = name;
		_tmp11_ = _tmp4_;
		_tmp12_ = string_replace (_tmp10_, "~/", _tmp11_);
		_g_free0 (filename);
		filename = _tmp12_;
		_g_free0 (_tmp4_);
	}
	{
		const gchar* _tmp13_ = NULL;
		gboolean _tmp14_ = FALSE;
		_tmp13_ = filename;
		_tmp14_ = g_str_has_prefix (_tmp13_, "file://");
		if (_tmp14_) {
			GdkPixbuf* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			GFile* _tmp17_ = NULL;
			GFile* _tmp18_ = NULL;
			gchar* _tmp19_ = NULL;
			gchar* _tmp20_ = NULL;
			GdkPixbuf* _tmp21_ = NULL;
			GdkPixbuf* _tmp22_ = NULL;
			_tmp16_ = filename;
			_tmp17_ = g_file_new_for_uri (_tmp16_);
			_tmp18_ = _tmp17_;
			_tmp19_ = g_file_get_path (_tmp18_);
			_tmp20_ = _tmp19_;
			_tmp21_ = gdk_pixbuf_new_from_file (_tmp20_, &_inner_error_);
			_tmp22_ = _tmp21_;
			_g_free0 (_tmp20_);
			_g_object_unref0 (_tmp18_);
			_tmp15_ = _tmp22_;
			if (_inner_error_ != NULL) {
				goto __catch3_g_error;
			}
			_g_object_unref0 (pbuf);
			pbuf = _tmp15_;
		} else {
			GdkPixbuf* _tmp23_ = NULL;
			const gchar* _tmp24_ = NULL;
			GFile* _tmp25_ = NULL;
			GFile* _tmp26_ = NULL;
			gchar* _tmp27_ = NULL;
			gchar* _tmp28_ = NULL;
			GdkPixbuf* _tmp29_ = NULL;
			GdkPixbuf* _tmp30_ = NULL;
			_tmp24_ = filename;
			_tmp25_ = g_file_new_for_path (_tmp24_);
			_tmp26_ = _tmp25_;
			_tmp27_ = g_file_get_path (_tmp26_);
			_tmp28_ = _tmp27_;
			_tmp29_ = gdk_pixbuf_new_from_file (_tmp28_, &_inner_error_);
			_tmp30_ = _tmp29_;
			_g_free0 (_tmp28_);
			_g_object_unref0 (_tmp26_);
			_tmp23_ = _tmp30_;
			if (_inner_error_ != NULL) {
				goto __catch3_g_error;
			}
			_g_object_unref0 (pbuf);
			pbuf = _tmp23_;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally3:
	if (_inner_error_ != NULL) {
		_g_free0 (filename);
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = pbuf;
	_g_free0 (filename);
	return result;
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf (const gchar* icon, gint size) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (icon != NULL, NULL);
	pbuf = NULL;
	_tmp0_ = gtk_icon_theme_get_default ();
	icon_theme = _tmp0_;
	{
		GtkIconTheme* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
		_tmp1_ = icon_theme;
		_tmp2_ = icon;
		_tmp3_ = gtk_icon_theme_has_icon (_tmp1_, _tmp2_);
		if (_tmp3_) {
			GdkPixbuf* _tmp4_ = NULL;
			GtkIconTheme* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			gint _tmp7_ = 0;
			GdkPixbuf* _tmp8_ = NULL;
			_tmp5_ = icon_theme;
			_tmp6_ = icon;
			_tmp7_ = size;
			_tmp8_ = gtk_icon_theme_load_icon (_tmp5_, _tmp6_, _tmp7_, 0, &_inner_error_);
			_tmp4_ = _tmp8_;
			if (_inner_error_ != NULL) {
				goto __catch4_g_error;
			}
			_g_object_unref0 (pbuf);
			pbuf = _tmp4_;
		} else {
			const gchar* _tmp9_ = NULL;
			gboolean _tmp10_ = FALSE;
			_tmp9_ = icon;
			_tmp10_ = string_contains (_tmp9_, ".");
			if (_tmp10_) {
				gchar** parts = NULL;
				const gchar* _tmp11_ = NULL;
				gchar** _tmp12_ = NULL;
				gchar** _tmp13_ = NULL;
				gint parts_length1 = 0;
				gint _parts_size_ = 0;
				GtkIconTheme* _tmp14_ = NULL;
				gchar** _tmp15_ = NULL;
				gint _tmp15__length1 = 0;
				const gchar* _tmp16_ = NULL;
				gboolean _tmp17_ = FALSE;
				_tmp11_ = icon;
				_tmp13_ = _tmp12_ = g_strsplit (_tmp11_, ".", 0);
				parts = _tmp13_;
				parts_length1 = _vala_array_length (_tmp12_);
				_parts_size_ = parts_length1;
				_tmp14_ = icon_theme;
				_tmp15_ = parts;
				_tmp15__length1 = parts_length1;
				_tmp16_ = _tmp15_[0];
				_tmp17_ = gtk_icon_theme_has_icon (_tmp14_, _tmp16_);
				if (_tmp17_) {
					GdkPixbuf* _tmp18_ = NULL;
					GtkIconTheme* _tmp19_ = NULL;
					gchar** _tmp20_ = NULL;
					gint _tmp20__length1 = 0;
					const gchar* _tmp21_ = NULL;
					gint _tmp22_ = 0;
					GdkPixbuf* _tmp23_ = NULL;
					_tmp19_ = icon_theme;
					_tmp20_ = parts;
					_tmp20__length1 = parts_length1;
					_tmp21_ = _tmp20_[0];
					_tmp22_ = size;
					_tmp23_ = gtk_icon_theme_load_icon (_tmp19_, _tmp21_, _tmp22_, 0, &_inner_error_);
					_tmp18_ = _tmp23_;
					if (_inner_error_ != NULL) {
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
						goto __catch4_g_error;
					}
					_g_object_unref0 (pbuf);
					pbuf = _tmp18_;
				}
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
			}
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally4:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = pbuf;
	return result;
}


/**
 * Scales a {@link Gdk.Pixbuf}, maintaining the original aspect ratio.
 *
 * @param source the pixbuf to scale
 * @param width the width of the scaled pixbuf
 * @param height the height of the scaled pixbuf
 * @return the scaled pixbuf
 */
GdkPixbuf* plank_drawing_drawing_service_ar_scale (GdkPixbuf* source, gint width, gint height) {
	GdkPixbuf* result = NULL;
	gdouble xScale = 0.0;
	gint _tmp0_ = 0;
	GdkPixbuf* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gdouble yScale = 0.0;
	gint _tmp4_ = 0;
	GdkPixbuf* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gdouble scale = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gint scaled_width = 0;
	GdkPixbuf* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gdouble _tmp17_ = 0.0;
	gint _tmp18_ = 0;
	gint scaled_height = 0;
	GdkPixbuf* _tmp19_ = NULL;
	gint _tmp20_ = 0;
	gint _tmp21_ = 0;
	gdouble _tmp22_ = 0.0;
	gint _tmp23_ = 0;
	GdkPixbuf* _tmp24_ = NULL;
	gint _tmp25_ = 0;
	gint _tmp26_ = 0;
	GdkPixbuf* _tmp27_ = NULL;
	g_return_val_if_fail (source != NULL, NULL);
	_tmp0_ = width;
	_tmp1_ = source;
	_tmp2_ = gdk_pixbuf_get_width (_tmp1_);
	_tmp3_ = _tmp2_;
	xScale = ((gdouble) _tmp0_) / ((gdouble) _tmp3_);
	_tmp4_ = height;
	_tmp5_ = source;
	_tmp6_ = gdk_pixbuf_get_height (_tmp5_);
	_tmp7_ = _tmp6_;
	yScale = ((gdouble) _tmp4_) / ((gdouble) _tmp7_);
	_tmp8_ = xScale;
	_tmp9_ = yScale;
	_tmp10_ = MIN (_tmp8_, _tmp9_);
	scale = _tmp10_;
	_tmp11_ = scale;
	if (_tmp11_ == ((gdouble) 1)) {
		GdkPixbuf* _tmp12_ = NULL;
		GdkPixbuf* _tmp13_ = NULL;
		_tmp12_ = source;
		_tmp13_ = _g_object_ref0 (_tmp12_);
		result = _tmp13_;
		return result;
	}
	_tmp14_ = source;
	_tmp15_ = gdk_pixbuf_get_width (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = scale;
	_tmp18_ = MAX (1, (gint) (_tmp16_ * _tmp17_));
	scaled_width = _tmp18_;
	_tmp19_ = source;
	_tmp20_ = gdk_pixbuf_get_height (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = scale;
	_tmp23_ = MAX (1, (gint) (_tmp21_ * _tmp22_));
	scaled_height = _tmp23_;
	_tmp24_ = source;
	_tmp25_ = scaled_width;
	_tmp26_ = scaled_height;
	_tmp27_ = gdk_pixbuf_scale_simple (_tmp24_, _tmp25_, _tmp26_, GDK_INTERP_HYPER);
	result = _tmp27_;
	return result;
}


/**
 * Computes and returns the average color of a {@link Gdk.Pixbuf}.
 * The resulting color is the average of all pixels which aren't
 * nearly transparent while saturated pixels are weighted more than
 * "grey" ones.
 *
 * @param source the pixbuf to use
 * @return the average color of the pixbuf
 */
void plank_drawing_drawing_service_average_color (GdkPixbuf* source, PlankDrawingColor* result) {
	guint8 r = 0U;
	guint8 g = 0U;
	guint8 b = 0U;
	guint8 a = 0U;
	guint8 min = 0U;
	guint8 max = 0U;
	gdouble delta = 0.0;
	gdouble rTotal = 0.0;
	gdouble gTotal = 0.0;
	gdouble bTotal = 0.0;
	gdouble bTotal2 = 0.0;
	gdouble gTotal2 = 0.0;
	gdouble rTotal2 = 0.0;
	gdouble aTotal2 = 0.0;
	guint8* dataPtr = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	guint8* _tmp1_ = NULL;
	gint n_channels = 0;
	GdkPixbuf* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint width = 0;
	GdkPixbuf* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gint height = 0;
	GdkPixbuf* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gint rowstride = 0;
	GdkPixbuf* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	gint length = 0;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	gint pixels = 0;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gdouble scoreTotal = 0.0;
	gint _tmp77_ = 0;
	gdouble _tmp79_ = 0.0;
	gint _tmp80_ = 0;
	gdouble _tmp81_ = 0.0;
	gint _tmp82_ = 0;
	gdouble _tmp83_ = 0.0;
	gint _tmp84_ = 0;
	gdouble _tmp85_ = 0.0;
	gint _tmp86_ = 0;
	gdouble _tmp87_ = 0.0;
	gdouble _tmp94_ = 0.0;
	gint _tmp95_ = 0;
	guint8 _tmp96_ = 0U;
	gdouble _tmp97_ = 0.0;
	gint _tmp98_ = 0;
	guint8 _tmp99_ = 0U;
	gdouble _tmp100_ = 0.0;
	gint _tmp101_ = 0;
	guint8 _tmp102_ = 0U;
	gdouble _tmp103_ = 0.0;
	gint _tmp104_ = 0;
	guint8 _tmp105_ = 0U;
	gdouble _tmp106_ = 0.0;
	gdouble max_val = 0.0;
	gdouble _tmp121_ = 0.0;
	gdouble _tmp122_ = 0.0;
	gdouble _tmp123_ = 0.0;
	gdouble _tmp124_ = 0.0;
	gdouble _tmp125_ = 0.0;
	gdouble _tmp126_ = 0.0;
	gdouble _tmp133_ = 0.0;
	gdouble _tmp134_ = 0.0;
	gdouble _tmp135_ = 0.0;
	gdouble _tmp136_ = 0.0;
	PlankDrawingColor _tmp137_ = {0};
	g_return_if_fail (source != NULL);
	rTotal = 0.0;
	gTotal = 0.0;
	bTotal = 0.0;
	bTotal2 = 0.0;
	gTotal2 = 0.0;
	rTotal2 = 0.0;
	aTotal2 = 0.0;
	_tmp0_ = source;
	_tmp1_ = gdk_pixbuf_get_pixels (_tmp0_);
	dataPtr = _tmp1_;
	_tmp2_ = source;
	_tmp3_ = gdk_pixbuf_get_n_channels (_tmp2_);
	_tmp4_ = _tmp3_;
	n_channels = _tmp4_;
	_tmp5_ = source;
	_tmp6_ = gdk_pixbuf_get_width (_tmp5_);
	_tmp7_ = _tmp6_;
	width = _tmp7_;
	_tmp8_ = source;
	_tmp9_ = gdk_pixbuf_get_height (_tmp8_);
	_tmp10_ = _tmp9_;
	height = _tmp10_;
	_tmp11_ = source;
	_tmp12_ = gdk_pixbuf_get_rowstride (_tmp11_);
	_tmp13_ = _tmp12_;
	rowstride = _tmp13_;
	_tmp14_ = width;
	_tmp15_ = height;
	length = _tmp14_ * _tmp15_;
	_tmp16_ = height;
	_tmp17_ = rowstride;
	_tmp18_ = n_channels;
	pixels = (_tmp16_ * _tmp17_) / _tmp18_;
	scoreTotal = 0.0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp19_ = FALSE;
			_tmp19_ = TRUE;
			while (TRUE) {
				gboolean _tmp20_ = FALSE;
				gint _tmp22_ = 0;
				gint _tmp23_ = 0;
				guint8* _tmp24_ = NULL;
				guint8 _tmp25_ = 0U;
				guint8* _tmp26_ = NULL;
				guint8 _tmp27_ = 0U;
				guint8* _tmp28_ = NULL;
				guint8 _tmp29_ = 0U;
				guint8* _tmp30_ = NULL;
				guint8 _tmp31_ = 0U;
				guint8 _tmp32_ = 0U;
				guint8 _tmp36_ = 0U;
				guint8 _tmp37_ = 0U;
				guint8 _tmp38_ = 0U;
				guint8 _tmp39_ = 0U;
				guint8 _tmp40_ = 0U;
				guint8 _tmp41_ = 0U;
				guint8 _tmp42_ = 0U;
				guint8 _tmp43_ = 0U;
				guint8 _tmp44_ = 0U;
				guint8 _tmp45_ = 0U;
				guint8 _tmp46_ = 0U;
				guint8 _tmp47_ = 0U;
				gdouble _tmp48_ = 0.0;
				gdouble _tmp49_ = 0.0;
				gdouble score = 0.0;
				gdouble _tmp52_ = 0.0;
				gdouble _tmp53_ = 0.0;
				gdouble _tmp54_ = 0.0;
				guint8 _tmp55_ = 0U;
				guint8 _tmp56_ = 0U;
				gdouble _tmp57_ = 0.0;
				gdouble _tmp58_ = 0.0;
				guint8 _tmp59_ = 0U;
				guint8 _tmp60_ = 0U;
				gdouble _tmp61_ = 0.0;
				gdouble _tmp62_ = 0.0;
				guint8 _tmp63_ = 0U;
				guint8 _tmp64_ = 0U;
				gdouble _tmp65_ = 0.0;
				gdouble _tmp66_ = 0.0;
				gdouble _tmp67_ = 0.0;
				guint8 _tmp68_ = 0U;
				gdouble _tmp69_ = 0.0;
				guint8 _tmp70_ = 0U;
				gdouble _tmp71_ = 0.0;
				guint8 _tmp72_ = 0U;
				gdouble _tmp73_ = 0.0;
				guint8 _tmp74_ = 0U;
				guint8* _tmp75_ = NULL;
				gint _tmp76_ = 0;
				_tmp20_ = _tmp19_;
				if (!_tmp20_) {
					gint _tmp21_ = 0;
					_tmp21_ = i;
					i = _tmp21_ + 1;
				}
				_tmp19_ = FALSE;
				_tmp22_ = i;
				_tmp23_ = pixels;
				if (!(_tmp22_ < _tmp23_)) {
					break;
				}
				_tmp24_ = dataPtr;
				_tmp25_ = _tmp24_[0];
				r = _tmp25_;
				_tmp26_ = dataPtr;
				_tmp27_ = _tmp26_[1];
				g = _tmp27_;
				_tmp28_ = dataPtr;
				_tmp29_ = _tmp28_[2];
				b = _tmp29_;
				_tmp30_ = dataPtr;
				_tmp31_ = _tmp30_[3];
				a = _tmp31_;
				_tmp32_ = a;
				if (_tmp32_ <= PLANK_DRAWING_DRAWING_SERVICE_ALPHA_THRESHOLD) {
					gint _tmp33_ = 0;
					guint8* _tmp34_ = NULL;
					gint _tmp35_ = 0;
					_tmp33_ = length;
					length = _tmp33_ - 1;
					_tmp34_ = dataPtr;
					_tmp35_ = n_channels;
					dataPtr = _tmp34_ + _tmp35_;
					continue;
				}
				_tmp36_ = r;
				_tmp37_ = g;
				_tmp38_ = b;
				_tmp39_ = MIN (_tmp37_, _tmp38_);
				_tmp40_ = MIN (_tmp36_, _tmp39_);
				min = _tmp40_;
				_tmp41_ = r;
				_tmp42_ = g;
				_tmp43_ = b;
				_tmp44_ = MAX (_tmp42_, _tmp43_);
				_tmp45_ = MAX (_tmp41_, _tmp44_);
				max = _tmp45_;
				_tmp46_ = max;
				_tmp47_ = min;
				delta = (gdouble) (_tmp46_ - _tmp47_);
				_tmp49_ = delta;
				if (_tmp49_ == ((gdouble) 0)) {
					_tmp48_ = 0.0;
				} else {
					gdouble _tmp50_ = 0.0;
					guint8 _tmp51_ = 0U;
					_tmp50_ = delta;
					_tmp51_ = max;
					_tmp48_ = _tmp50_ / _tmp51_;
				}
				_tmp52_ = _tmp48_;
				score = PLANK_DRAWING_DRAWING_SERVICE_SATURATION_WEIGHT * _tmp52_;
				_tmp53_ = bTotal;
				_tmp54_ = score;
				_tmp55_ = b;
				_tmp56_ = a;
				bTotal = _tmp53_ + ((_tmp54_ * _tmp55_) / _tmp56_);
				_tmp57_ = gTotal;
				_tmp58_ = score;
				_tmp59_ = g;
				_tmp60_ = a;
				gTotal = _tmp57_ + ((_tmp58_ * _tmp59_) / _tmp60_);
				_tmp61_ = rTotal;
				_tmp62_ = score;
				_tmp63_ = r;
				_tmp64_ = a;
				rTotal = _tmp61_ + ((_tmp62_ * _tmp63_) / _tmp64_);
				_tmp65_ = scoreTotal;
				_tmp66_ = score;
				scoreTotal = _tmp65_ + _tmp66_;
				_tmp67_ = bTotal2;
				_tmp68_ = b;
				bTotal2 = _tmp67_ + _tmp68_;
				_tmp69_ = gTotal2;
				_tmp70_ = g;
				gTotal2 = _tmp69_ + _tmp70_;
				_tmp71_ = rTotal2;
				_tmp72_ = r;
				rTotal2 = _tmp71_ + _tmp72_;
				_tmp73_ = aTotal2;
				_tmp74_ = a;
				aTotal2 = _tmp73_ + _tmp74_;
				_tmp75_ = dataPtr;
				_tmp76_ = n_channels;
				dataPtr = _tmp75_ + _tmp76_;
			}
		}
	}
	_tmp77_ = length;
	if (_tmp77_ <= 0) {
		PlankDrawingColor _tmp78_ = {0};
		_tmp78_.R = 0.0;
		_tmp78_.G = 0.0;
		_tmp78_.B = 0.0;
		_tmp78_.A = 0.0;
		*result = _tmp78_;
		return;
	}
	_tmp79_ = scoreTotal;
	_tmp80_ = length;
	scoreTotal = _tmp79_ / _tmp80_;
	_tmp81_ = bTotal;
	_tmp82_ = length;
	bTotal = _tmp81_ / _tmp82_;
	_tmp83_ = gTotal;
	_tmp84_ = length;
	gTotal = _tmp83_ / _tmp84_;
	_tmp85_ = rTotal;
	_tmp86_ = length;
	rTotal = _tmp85_ / _tmp86_;
	_tmp87_ = scoreTotal;
	if (_tmp87_ > 0.0) {
		gdouble _tmp88_ = 0.0;
		gdouble _tmp89_ = 0.0;
		gdouble _tmp90_ = 0.0;
		gdouble _tmp91_ = 0.0;
		gdouble _tmp92_ = 0.0;
		gdouble _tmp93_ = 0.0;
		_tmp88_ = bTotal;
		_tmp89_ = scoreTotal;
		bTotal = _tmp88_ / _tmp89_;
		_tmp90_ = gTotal;
		_tmp91_ = scoreTotal;
		gTotal = _tmp90_ / _tmp91_;
		_tmp92_ = rTotal;
		_tmp93_ = scoreTotal;
		rTotal = _tmp92_ / _tmp93_;
	}
	_tmp94_ = bTotal2;
	_tmp95_ = length;
	_tmp96_ = G_MAXUINT8;
	bTotal2 = _tmp94_ / (_tmp95_ * _tmp96_);
	_tmp97_ = gTotal2;
	_tmp98_ = length;
	_tmp99_ = G_MAXUINT8;
	gTotal2 = _tmp97_ / (_tmp98_ * _tmp99_);
	_tmp100_ = rTotal2;
	_tmp101_ = length;
	_tmp102_ = G_MAXUINT8;
	rTotal2 = _tmp100_ / (_tmp101_ * _tmp102_);
	_tmp103_ = aTotal2;
	_tmp104_ = length;
	_tmp105_ = G_MAXUINT8;
	aTotal2 = _tmp103_ / (_tmp104_ * _tmp105_);
	_tmp106_ = scoreTotal;
	if (_tmp106_ <= PLANK_DRAWING_DRAWING_SERVICE_WEIGHT_THRESHOLD) {
		gdouble f = 0.0;
		gdouble _tmp107_ = 0.0;
		gdouble rf = 0.0;
		gdouble _tmp108_ = 0.0;
		gdouble _tmp109_ = 0.0;
		gdouble _tmp110_ = 0.0;
		gdouble _tmp111_ = 0.0;
		gdouble _tmp112_ = 0.0;
		gdouble _tmp113_ = 0.0;
		gdouble _tmp114_ = 0.0;
		gdouble _tmp115_ = 0.0;
		gdouble _tmp116_ = 0.0;
		gdouble _tmp117_ = 0.0;
		gdouble _tmp118_ = 0.0;
		gdouble _tmp119_ = 0.0;
		gdouble _tmp120_ = 0.0;
		_tmp107_ = scoreTotal;
		f = (1.0 / PLANK_DRAWING_DRAWING_SERVICE_WEIGHT_THRESHOLD) * _tmp107_;
		_tmp108_ = f;
		rf = 1.0 - _tmp108_;
		_tmp109_ = bTotal;
		_tmp110_ = f;
		_tmp111_ = bTotal2;
		_tmp112_ = rf;
		bTotal = (_tmp109_ * _tmp110_) + (_tmp111_ * _tmp112_);
		_tmp113_ = gTotal;
		_tmp114_ = f;
		_tmp115_ = gTotal2;
		_tmp116_ = rf;
		gTotal = (_tmp113_ * _tmp114_) + (_tmp115_ * _tmp116_);
		_tmp117_ = rTotal;
		_tmp118_ = f;
		_tmp119_ = rTotal2;
		_tmp120_ = rf;
		rTotal = (_tmp117_ * _tmp118_) + (_tmp119_ * _tmp120_);
	}
	_tmp121_ = rTotal;
	_tmp122_ = gTotal;
	_tmp123_ = bTotal;
	_tmp124_ = MAX (_tmp122_, _tmp123_);
	_tmp125_ = MAX (_tmp121_, _tmp124_);
	max_val = _tmp125_;
	_tmp126_ = max_val;
	if (_tmp126_ > 1.0) {
		gdouble _tmp127_ = 0.0;
		gdouble _tmp128_ = 0.0;
		gdouble _tmp129_ = 0.0;
		gdouble _tmp130_ = 0.0;
		gdouble _tmp131_ = 0.0;
		gdouble _tmp132_ = 0.0;
		_tmp127_ = bTotal;
		_tmp128_ = max_val;
		bTotal = _tmp127_ / _tmp128_;
		_tmp129_ = gTotal;
		_tmp130_ = max_val;
		gTotal = _tmp129_ / _tmp130_;
		_tmp131_ = rTotal;
		_tmp132_ = max_val;
		rTotal = _tmp131_ / _tmp132_;
	}
	_tmp133_ = rTotal;
	_tmp134_ = gTotal;
	_tmp135_ = bTotal;
	_tmp136_ = aTotal2;
	_tmp137_.R = _tmp133_;
	_tmp137_.G = _tmp134_;
	_tmp137_.B = _tmp135_;
	_tmp137_.A = _tmp136_;
	*result = _tmp137_;
	return;
}


static void plank_drawing_drawing_service_class_init (PlankDrawingDrawingServiceClass * klass) {
	plank_drawing_drawing_service_parent_class = g_type_class_peek_parent (klass);
}


static void plank_drawing_drawing_service_instance_init (PlankDrawingDrawingService * self) {
}


/**
 * Utility service for loading icons and working with pixbufs.
 */
GType plank_drawing_drawing_service_get_type (void) {
	static volatile gsize plank_drawing_drawing_service_type_id__volatile = 0;
	if (g_once_init_enter (&plank_drawing_drawing_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankDrawingDrawingServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_drawing_drawing_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDrawingDrawingService), 0, (GInstanceInitFunc) plank_drawing_drawing_service_instance_init, NULL };
		GType plank_drawing_drawing_service_type_id;
		plank_drawing_drawing_service_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankDrawingDrawingService", &g_define_type_info, 0);
		g_once_init_leave (&plank_drawing_drawing_service_type_id__volatile, plank_drawing_drawing_service_type_id);
	}
	return plank_drawing_drawing_service_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



