/* DockItemProvider.c generated by valac 0.22.1, the Vala compiler
 * generated from DockItemProvider.vala, do not modify */

/**/
/*  Copyright (C) 2011-2013 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER (plank_items_dock_item_provider_get_type ())
#define PLANK_ITEMS_DOCK_ITEM_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER, PlankItemsDockItemProvider))
#define PLANK_ITEMS_DOCK_ITEM_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER, PlankItemsDockItemProviderClass))
#define PLANK_ITEMS_IS_DOCK_ITEM_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER))
#define PLANK_ITEMS_IS_DOCK_ITEM_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER))
#define PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER, PlankItemsDockItemProviderClass))

typedef struct _PlankItemsDockItemProvider PlankItemsDockItemProvider;
typedef struct _PlankItemsDockItemProviderClass PlankItemsDockItemProviderClass;
typedef struct _PlankItemsDockItemProviderPrivate PlankItemsDockItemProviderPrivate;

#define PLANK_ITEMS_TYPE_DOCK_ITEM (plank_items_dock_item_get_type ())
#define PLANK_ITEMS_DOCK_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_ITEMS_TYPE_DOCK_ITEM, PlankItemsDockItem))
#define PLANK_ITEMS_DOCK_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_ITEMS_TYPE_DOCK_ITEM, PlankItemsDockItemClass))
#define PLANK_ITEMS_IS_DOCK_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_ITEMS_TYPE_DOCK_ITEM))
#define PLANK_ITEMS_IS_DOCK_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_ITEMS_TYPE_DOCK_ITEM))
#define PLANK_ITEMS_DOCK_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_ITEMS_TYPE_DOCK_ITEM, PlankItemsDockItemClass))

typedef struct _PlankItemsDockItem PlankItemsDockItem;
typedef struct _PlankItemsDockItemClass PlankItemsDockItemClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PlankItemsDockItemProvider {
	GObject parent_instance;
	PlankItemsDockItemProviderPrivate * priv;
	GeeArrayList* visible_items;
	GeeArrayList* internal_items;
	GeeMap* saved_item_positions;
};

struct _PlankItemsDockItemProviderClass {
	GObjectClass parent_class;
	void (*update_visible_items) (PlankItemsDockItemProvider* self);
	void (*move_item_to) (PlankItemsDockItemProvider* self, PlankItemsDockItem* move, PlankItemsDockItem* target);
	gboolean (*item_exists_for_uri) (PlankItemsDockItemProvider* self, const gchar* uri);
	void (*add_item_with_uri) (PlankItemsDockItemProvider* self, const gchar* uri, PlankItemsDockItem* target);
	void (*add_item_without_signaling) (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
	void (*replace_item) (PlankItemsDockItemProvider* self, PlankItemsDockItem* new_item, PlankItemsDockItem* old_item);
	void (*remove_item_without_signaling) (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
	void (*item_signals_connect) (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
	void (*item_signals_disconnect) (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
	void (*handle_item_deleted) (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
	gboolean (*can_accept_drop) (PlankItemsDockItemProvider* self, GeeArrayList* uris);
	gboolean (*accept_drop) (PlankItemsDockItemProvider* self, GeeArrayList* uris);
};

struct _PlankItemsDockItemProviderPrivate {
	gint first_item_position;
};


static gpointer plank_items_dock_item_provider_parent_class = NULL;

GType plank_items_dock_item_provider_get_type (void) G_GNUC_CONST;
GType plank_items_dock_item_get_type (void) G_GNUC_CONST;
#define PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER, PlankItemsDockItemProviderPrivate))
enum  {
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_DUMMY_PROPERTY,
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_ITEMS,
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_FIRST_ITEM_POSITION
};
void plank_items_dock_item_provider_remove_item_without_signaling (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
void plank_items_dock_item_set_Provider (PlankItemsDockItem* self, PlankItemsDockItemProvider* value);
PlankItemsDockItemProvider* plank_items_dock_item_provider_new (void);
PlankItemsDockItemProvider* plank_items_dock_item_provider_construct (GType object_type);
void plank_items_dock_item_provider_add_item (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
const gchar* plank_items_dock_item_get_Text (PlankItemsDockItem* self);
void plank_items_dock_item_provider_add_item_without_signaling (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
void plank_items_dock_item_provider_update_visible_items (PlankItemsDockItemProvider* self);
void plank_items_dock_item_provider_remove_item (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
void plank_items_dock_item_provider_handle_item_state_changed (PlankItemsDockItemProvider* self);
static void plank_items_dock_item_provider_real_update_visible_items (PlankItemsDockItemProvider* self);
void plank_services_logger_verbose (const gchar* msg, ...);
gboolean plank_items_dock_item_get_IsVisible (PlankItemsDockItem* self);
void plank_items_dock_item_provider_set_item_positions (PlankItemsDockItemProvider* self);
gint plank_items_dock_item_provider_get_FirstItemPosition (PlankItemsDockItemProvider* self);
gint plank_items_dock_item_get_Position (PlankItemsDockItem* self);
void plank_items_dock_item_set_Position (PlankItemsDockItem* self, gint value);
void plank_items_dock_item_provider_handle_setting_changed (PlankItemsDockItemProvider* self);
void plank_items_dock_item_provider_save_item_positions (PlankItemsDockItemProvider* self);
void plank_items_dock_item_provider_restore_item_positions (PlankItemsDockItemProvider* self);
gint plank_items_dock_item_provider_compare_items (PlankItemsDockItem* left, PlankItemsDockItem* right);
void plank_items_dock_item_provider_move_item_to (PlankItemsDockItemProvider* self, PlankItemsDockItem* move, PlankItemsDockItem* target);
static void plank_items_dock_item_provider_real_move_item_to (PlankItemsDockItemProvider* self, PlankItemsDockItem* move, PlankItemsDockItem* target);
void plank_items_dock_item_provider_reset_item_buffers (PlankItemsDockItemProvider* self);
void plank_items_dock_item_reset_buffers (PlankItemsDockItem* self);
gboolean plank_items_dock_item_provider_item_exists_for_uri (PlankItemsDockItemProvider* self, const gchar* uri);
static gboolean plank_items_dock_item_provider_real_item_exists_for_uri (PlankItemsDockItemProvider* self, const gchar* uri);
const gchar* plank_items_dock_item_get_Launcher (PlankItemsDockItem* self);
void plank_items_dock_item_provider_add_item_with_uri (PlankItemsDockItemProvider* self, const gchar* uri, PlankItemsDockItem* target);
static void plank_items_dock_item_provider_real_add_item_with_uri (PlankItemsDockItemProvider* self, const gchar* uri, PlankItemsDockItem* target);
static void plank_items_dock_item_provider_real_add_item_without_signaling (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
void plank_items_dock_item_set_AddTime (PlankItemsDockItem* self, GDateTime* value);
void plank_items_dock_item_provider_item_signals_connect (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
void plank_items_dock_item_provider_replace_item (PlankItemsDockItemProvider* self, PlankItemsDockItem* new_item, PlankItemsDockItem* old_item);
static void plank_items_dock_item_provider_real_replace_item (PlankItemsDockItemProvider* self, PlankItemsDockItem* new_item, PlankItemsDockItem* old_item);
gchar* plank_items_dock_item_get_DockItemFilename (PlankItemsDockItem* self);
void plank_items_dock_item_provider_item_signals_disconnect (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
GDateTime* plank_items_dock_item_get_AddTime (PlankItemsDockItem* self);
static void plank_items_dock_item_provider_real_remove_item_without_signaling (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
void plank_items_dock_item_set_RemoveTime (PlankItemsDockItem* self, GDateTime* value);
static void plank_items_dock_item_provider_real_item_signals_connect (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
static void _plank_items_dock_item_provider_handle_item_state_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _plank_items_dock_item_provider_handle_item_state_changed_plank_items_dock_item_needs_redraw (PlankItemsDockItem* _sender, gpointer self);
void plank_items_dock_item_provider_handle_item_deleted (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
static void _plank_items_dock_item_provider_handle_item_deleted_plank_items_dock_item_deleted (PlankItemsDockItem* _sender, gpointer self);
static void plank_items_dock_item_provider_real_item_signals_disconnect (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
static void plank_items_dock_item_provider_real_handle_item_deleted (PlankItemsDockItemProvider* self, PlankItemsDockItem* item);
gboolean plank_items_dock_item_provider_can_accept_drop (PlankItemsDockItemProvider* self, GeeArrayList* uris);
static gboolean plank_items_dock_item_provider_real_can_accept_drop (PlankItemsDockItemProvider* self, GeeArrayList* uris);
gboolean plank_items_dock_item_provider_accept_drop (PlankItemsDockItemProvider* self, GeeArrayList* uris);
static gboolean plank_items_dock_item_provider_real_accept_drop (PlankItemsDockItemProvider* self, GeeArrayList* uris);
GeeArrayList* plank_items_dock_item_provider_get_Items (PlankItemsDockItemProvider* self);
void plank_items_dock_item_provider_set_FirstItemPosition (PlankItemsDockItemProvider* self, gint value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static GObject * plank_items_dock_item_provider_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void plank_items_dock_item_provider_finalize (GObject* obj);
static void _vala_plank_items_dock_item_provider_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_plank_items_dock_item_provider_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Creates a new container for dock items.
 */
PlankItemsDockItemProvider* plank_items_dock_item_provider_construct (GType object_type) {
	PlankItemsDockItemProvider * self = NULL;
	self = (PlankItemsDockItemProvider*) g_object_new (object_type, NULL);
	return self;
}


PlankItemsDockItemProvider* plank_items_dock_item_provider_new (void) {
	return plank_items_dock_item_provider_construct (PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER);
}


/**
 * Adds a dock item to the collection.
 *
 * @param item the dock item to add
 */
void plank_items_dock_item_provider_add_item (PlankItemsDockItemProvider* self, PlankItemsDockItem* item) {
	GeeArrayList* _tmp0_ = NULL;
	PlankItemsDockItem* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	PlankItemsDockItem* _tmp6_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = self->internal_items;
	_tmp1_ = item;
	_tmp2_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, _tmp1_);
	if (_tmp2_) {
		PlankItemsDockItem* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		_tmp3_ = item;
		_tmp4_ = plank_items_dock_item_get_Text (_tmp3_);
		_tmp5_ = _tmp4_;
		g_critical ("DockItemProvider.vala:114: Item '%s' already exists in this item-provi" \
"der.", _tmp5_);
		return;
	}
	_tmp6_ = item;
	plank_items_dock_item_provider_add_item_without_signaling (self, _tmp6_);
	plank_items_dock_item_provider_update_visible_items (self);
}


/**
 * Removes a dock item from the collection.
 *
 * @param item the dock item to remove
 */
void plank_items_dock_item_provider_remove_item (PlankItemsDockItemProvider* self, PlankItemsDockItem* item) {
	GeeArrayList* _tmp0_ = NULL;
	PlankItemsDockItem* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	PlankItemsDockItem* _tmp6_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = self->internal_items;
	_tmp1_ = item;
	_tmp2_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, _tmp1_);
	if (!_tmp2_) {
		PlankItemsDockItem* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		_tmp3_ = item;
		_tmp4_ = plank_items_dock_item_get_Text (_tmp3_);
		_tmp5_ = _tmp4_;
		g_critical ("DockItemProvider.vala:131: Item '%s' does not exist in this item-provi" \
"der.", _tmp5_);
		return;
	}
	_tmp6_ = item;
	plank_items_dock_item_provider_remove_item_without_signaling (self, _tmp6_);
	plank_items_dock_item_provider_update_visible_items (self);
}


void plank_items_dock_item_provider_handle_item_state_changed (PlankItemsDockItemProvider* self) {
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name (self, "item-state-changed");
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void plank_items_dock_item_provider_real_update_visible_items (PlankItemsDockItemProvider* self) {
	GeeArrayList* old_items = NULL;
	GeeArrayList* _tmp0_ = NULL;
	GeeArrayList* _tmp1_ = NULL;
	GeeArrayList* _tmp2_ = NULL;
	GeeArrayList* _tmp3_ = NULL;
	GeeArrayList* added_items = NULL;
	GeeArrayList* _tmp20_ = NULL;
	GeeArrayList* _tmp21_ = NULL;
	GeeArrayList* _tmp22_ = NULL;
	GeeArrayList* _tmp23_ = NULL;
	GeeArrayList* _tmp24_ = NULL;
	GeeArrayList* removed_items = NULL;
	GeeArrayList* _tmp25_ = NULL;
	GeeArrayList* _tmp26_ = NULL;
	GeeArrayList* _tmp27_ = NULL;
	GeeArrayList* _tmp28_ = NULL;
	gboolean _tmp29_ = FALSE;
	GeeArrayList* _tmp30_ = NULL;
	gint _tmp31_ = 0;
	gint _tmp32_ = 0;
	gboolean _tmp36_ = FALSE;
	plank_services_logger_verbose ("DockItemProvider.update_visible_items ()", NULL);
	_tmp0_ = gee_array_list_new (PLANK_ITEMS_TYPE_DOCK_ITEM, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	old_items = _tmp0_;
	_tmp1_ = old_items;
	_tmp2_ = self->visible_items;
	gee_array_list_add_all (_tmp1_, (GeeCollection*) _tmp2_);
	_tmp3_ = self->visible_items;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp3_);
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp4_ = NULL;
		GeeArrayList* _tmp5_ = NULL;
		gint _item_size = 0;
		GeeArrayList* _tmp6_ = NULL;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		gint _item_index = 0;
		_tmp4_ = self->internal_items;
		_tmp5_ = _g_object_ref0 (_tmp4_);
		_item_list = _tmp5_;
		_tmp6_ = _item_list;
		_tmp7_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp6_);
		_tmp8_ = _tmp7_;
		_item_size = _tmp8_;
		_item_index = -1;
		while (TRUE) {
			gint _tmp9_ = 0;
			gint _tmp10_ = 0;
			gint _tmp11_ = 0;
			PlankItemsDockItem* item = NULL;
			GeeArrayList* _tmp12_ = NULL;
			gint _tmp13_ = 0;
			gpointer _tmp14_ = NULL;
			PlankItemsDockItem* _tmp15_ = NULL;
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_ = FALSE;
			_tmp9_ = _item_index;
			_item_index = _tmp9_ + 1;
			_tmp10_ = _item_index;
			_tmp11_ = _item_size;
			if (!(_tmp10_ < _tmp11_)) {
				break;
			}
			_tmp12_ = _item_list;
			_tmp13_ = _item_index;
			_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _tmp13_);
			item = (PlankItemsDockItem*) _tmp14_;
			_tmp15_ = item;
			_tmp16_ = plank_items_dock_item_get_IsVisible (_tmp15_);
			_tmp17_ = _tmp16_;
			if (_tmp17_) {
				GeeArrayList* _tmp18_ = NULL;
				PlankItemsDockItem* _tmp19_ = NULL;
				_tmp18_ = self->visible_items;
				_tmp19_ = item;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
			}
			_g_object_unref0 (item);
		}
		_g_object_unref0 (_item_list);
	}
	plank_items_dock_item_provider_set_item_positions (self);
	_tmp20_ = gee_array_list_new (PLANK_ITEMS_TYPE_DOCK_ITEM, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	added_items = _tmp20_;
	_tmp21_ = added_items;
	_tmp22_ = self->visible_items;
	gee_array_list_add_all (_tmp21_, (GeeCollection*) _tmp22_);
	_tmp23_ = added_items;
	_tmp24_ = old_items;
	gee_collection_remove_all ((GeeCollection*) _tmp23_, (GeeCollection*) _tmp24_);
	_tmp25_ = old_items;
	_tmp26_ = _g_object_ref0 (_tmp25_);
	removed_items = _tmp26_;
	_tmp27_ = removed_items;
	_tmp28_ = self->visible_items;
	gee_collection_remove_all ((GeeCollection*) _tmp27_, (GeeCollection*) _tmp28_);
	_tmp30_ = added_items;
	_tmp31_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp30_);
	_tmp32_ = _tmp31_;
	if (_tmp32_ > 0) {
		_tmp29_ = TRUE;
	} else {
		GeeArrayList* _tmp33_ = NULL;
		gint _tmp34_ = 0;
		gint _tmp35_ = 0;
		_tmp33_ = removed_items;
		_tmp34_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp33_);
		_tmp35_ = _tmp34_;
		_tmp29_ = _tmp35_ > 0;
	}
	_tmp36_ = _tmp29_;
	if (_tmp36_) {
		GeeArrayList* _tmp37_ = NULL;
		GeeArrayList* _tmp38_ = NULL;
		_tmp37_ = added_items;
		_tmp38_ = removed_items;
		g_signal_emit_by_name (self, "items-changed", (GeeList*) _tmp37_, (GeeList*) _tmp38_);
	}
	_g_object_unref0 (removed_items);
	_g_object_unref0 (added_items);
	_g_object_unref0 (old_items);
}


void plank_items_dock_item_provider_update_visible_items (PlankItemsDockItemProvider* self) {
	g_return_if_fail (self != NULL);
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_CLASS (self)->update_visible_items (self);
}


void plank_items_dock_item_provider_set_item_positions (PlankItemsDockItemProvider* self) {
	gint pos = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = plank_items_dock_item_provider_get_FirstItemPosition (self);
	_tmp1_ = _tmp0_;
	pos = _tmp1_;
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp2_ = NULL;
		GeeArrayList* _tmp3_ = NULL;
		gint _item_size = 0;
		GeeArrayList* _tmp4_ = NULL;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		gint _item_index = 0;
		_tmp2_ = self->visible_items;
		_tmp3_ = _g_object_ref0 (_tmp2_);
		_item_list = _tmp3_;
		_tmp4_ = _item_list;
		_tmp5_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_item_size = _tmp6_;
		_item_index = -1;
		while (TRUE) {
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
			gint _tmp9_ = 0;
			PlankItemsDockItem* item = NULL;
			GeeArrayList* _tmp10_ = NULL;
			gint _tmp11_ = 0;
			gpointer _tmp12_ = NULL;
			PlankItemsDockItem* _tmp13_ = NULL;
			gint _tmp14_ = 0;
			gint _tmp15_ = 0;
			gint _tmp16_ = 0;
			gint _tmp20_ = 0;
			_tmp7_ = _item_index;
			_item_index = _tmp7_ + 1;
			_tmp8_ = _item_index;
			_tmp9_ = _item_size;
			if (!(_tmp8_ < _tmp9_)) {
				break;
			}
			_tmp10_ = _item_list;
			_tmp11_ = _item_index;
			_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _tmp11_);
			item = (PlankItemsDockItem*) _tmp12_;
			_tmp13_ = item;
			_tmp14_ = plank_items_dock_item_get_Position (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = pos;
			if (_tmp15_ != _tmp16_) {
				PlankItemsDockItem* _tmp17_ = NULL;
				gint _tmp18_ = 0;
				PlankItemsDockItem* _tmp19_ = NULL;
				_tmp17_ = item;
				_tmp18_ = pos;
				plank_items_dock_item_set_Position (_tmp17_, _tmp18_);
				_tmp19_ = item;
				g_signal_emit_by_name (self, "item-position-changed", _tmp19_);
			}
			_tmp20_ = pos;
			pos = _tmp20_ + 1;
			_g_object_unref0 (item);
		}
		_g_object_unref0 (_item_list);
	}
}


void plank_items_dock_item_provider_handle_setting_changed (PlankItemsDockItemProvider* self) {
	g_return_if_fail (self != NULL);
	plank_items_dock_item_provider_update_visible_items (self);
}


/**
 * Save current item positions
 */
void plank_items_dock_item_provider_save_item_positions (PlankItemsDockItemProvider* self) {
	GeeMap* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->saved_item_positions;
	gee_map_clear (_tmp0_);
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp1_ = NULL;
		GeeArrayList* _tmp2_ = NULL;
		gint _item_size = 0;
		GeeArrayList* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		gint _item_index = 0;
		_tmp1_ = self->visible_items;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_item_list = _tmp2_;
		_tmp3_ = _item_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_item_size = _tmp5_;
		_item_index = -1;
		while (TRUE) {
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
			PlankItemsDockItem* item = NULL;
			GeeArrayList* _tmp9_ = NULL;
			gint _tmp10_ = 0;
			gpointer _tmp11_ = NULL;
			GeeMap* _tmp12_ = NULL;
			PlankItemsDockItem* _tmp13_ = NULL;
			PlankItemsDockItem* _tmp14_ = NULL;
			gint _tmp15_ = 0;
			gint _tmp16_ = 0;
			_tmp6_ = _item_index;
			_item_index = _tmp6_ + 1;
			_tmp7_ = _item_index;
			_tmp8_ = _item_size;
			if (!(_tmp7_ < _tmp8_)) {
				break;
			}
			_tmp9_ = _item_list;
			_tmp10_ = _item_index;
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
			item = (PlankItemsDockItem*) _tmp11_;
			_tmp12_ = self->saved_item_positions;
			_tmp13_ = item;
			_tmp14_ = item;
			_tmp15_ = plank_items_dock_item_get_Position (_tmp14_);
			_tmp16_ = _tmp15_;
			gee_map_set (_tmp12_, _tmp13_, (gpointer) ((gintptr) _tmp16_));
			_g_object_unref0 (item);
		}
		_g_object_unref0 (_item_list);
	}
}


/**
 * Restore previously saved item positions
 */
void plank_items_dock_item_provider_restore_item_positions (PlankItemsDockItemProvider* self) {
	GeeMap* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GeeArrayList* _tmp19_ = NULL;
	GeeMap* _tmp20_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->saved_item_positions;
	_tmp1_ = gee_map_get_size (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == 0) {
		return;
	}
	{
		GeeIterator* _entry_it = NULL;
		GeeMap* _tmp3_ = NULL;
		GeeSet* _tmp4_ = NULL;
		GeeSet* _tmp5_ = NULL;
		GeeSet* _tmp6_ = NULL;
		GeeIterator* _tmp7_ = NULL;
		GeeIterator* _tmp8_ = NULL;
		_tmp3_ = self->saved_item_positions;
		_tmp4_ = gee_map_get_entries (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = _tmp5_;
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
		_tmp8_ = _tmp7_;
		_g_object_unref0 (_tmp6_);
		_entry_it = _tmp8_;
		while (TRUE) {
			GeeIterator* _tmp9_ = NULL;
			gboolean _tmp10_ = FALSE;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp11_ = NULL;
			gpointer _tmp12_ = NULL;
			GeeMapEntry* _tmp13_ = NULL;
			gconstpointer _tmp14_ = NULL;
			PlankItemsDockItem* _tmp15_ = NULL;
			GeeMapEntry* _tmp16_ = NULL;
			gconstpointer _tmp17_ = NULL;
			gint _tmp18_ = 0;
			_tmp9_ = _entry_it;
			_tmp10_ = gee_iterator_next (_tmp9_);
			if (!_tmp10_) {
				break;
			}
			_tmp11_ = _entry_it;
			_tmp12_ = gee_iterator_get (_tmp11_);
			entry = (GeeMapEntry*) _tmp12_;
			_tmp13_ = entry;
			_tmp14_ = gee_map_entry_get_key (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = entry;
			_tmp17_ = gee_map_entry_get_value (_tmp16_);
			_tmp18_ = _tmp17_;
			plank_items_dock_item_set_Position ((PlankItemsDockItem*) _tmp15_, (gint) ((gintptr) _tmp18_));
			_g_object_unref0 (entry);
		}
		_g_object_unref0 (_entry_it);
	}
	_tmp19_ = self->visible_items;
	gee_list_sort ((GeeList*) _tmp19_, (GCompareDataFunc) plank_items_dock_item_provider_compare_items, NULL, NULL);
	_tmp20_ = self->saved_item_positions;
	gee_map_clear (_tmp20_);
	plank_items_dock_item_provider_set_item_positions (self);
}


/**
 * Move an item to the position of another item.
 * This shifts all items which are between these two items.
 *
 * @param move the item to move
 * @param target the item of the new position
 */
static void plank_items_dock_item_provider_real_move_item_to (PlankItemsDockItemProvider* self, PlankItemsDockItem* move, PlankItemsDockItem* target) {
	gboolean _tmp0_ = FALSE;
	PlankItemsDockItem* _tmp1_ = NULL;
	PlankItemsDockItem* _tmp2_ = NULL;
	gboolean _tmp6_ = FALSE;
	gint index_target = 0;
	GeeArrayList* _tmp7_ = NULL;
	PlankItemsDockItem* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	GeeArrayList* _tmp10_ = NULL;
	PlankItemsDockItem* _tmp11_ = NULL;
	GeeArrayList* _tmp12_ = NULL;
	gint _tmp13_ = 0;
	PlankItemsDockItem* _tmp14_ = NULL;
	gboolean _tmp15_ = FALSE;
	GeeArrayList* _tmp16_ = NULL;
	PlankItemsDockItem* _tmp17_ = NULL;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp23_ = FALSE;
	g_return_if_fail (move != NULL);
	g_return_if_fail (target != NULL);
	_tmp1_ = move;
	_tmp2_ = target;
	if (_tmp1_ == _tmp2_) {
		_tmp0_ = TRUE;
	} else {
		GeeArrayList* _tmp3_ = NULL;
		PlankItemsDockItem* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
		_tmp3_ = self->internal_items;
		_tmp4_ = target;
		_tmp5_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp3_, _tmp4_);
		_tmp0_ = !_tmp5_;
	}
	_tmp6_ = _tmp0_;
	if (_tmp6_) {
		return;
	}
	_tmp7_ = self->internal_items;
	_tmp8_ = target;
	_tmp9_ = gee_abstract_list_index_of ((GeeAbstractList*) _tmp7_, _tmp8_);
	index_target = _tmp9_;
	_tmp10_ = self->internal_items;
	_tmp11_ = move;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp10_, _tmp11_);
	_tmp12_ = self->internal_items;
	_tmp13_ = index_target;
	_tmp14_ = move;
	gee_abstract_list_insert ((GeeAbstractList*) _tmp12_, _tmp13_, _tmp14_);
	_tmp16_ = self->visible_items;
	_tmp17_ = move;
	_tmp18_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp16_, _tmp17_);
	if (_tmp18_) {
		GeeArrayList* _tmp19_ = NULL;
		PlankItemsDockItem* _tmp20_ = NULL;
		gint _tmp21_ = 0;
		gint _tmp22_ = 0;
		_tmp19_ = self->visible_items;
		_tmp20_ = target;
		_tmp21_ = gee_abstract_list_index_of ((GeeAbstractList*) _tmp19_, _tmp20_);
		index_target = _tmp21_;
		_tmp22_ = index_target;
		_tmp15_ = _tmp22_ >= 0;
	} else {
		_tmp15_ = FALSE;
	}
	_tmp23_ = _tmp15_;
	if (_tmp23_) {
		GeeArrayList* _tmp24_ = NULL;
		PlankItemsDockItem* _tmp25_ = NULL;
		GeeArrayList* _tmp26_ = NULL;
		gint _tmp27_ = 0;
		PlankItemsDockItem* _tmp28_ = NULL;
		_tmp24_ = self->visible_items;
		_tmp25_ = move;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp24_, _tmp25_);
		_tmp26_ = self->visible_items;
		_tmp27_ = index_target;
		_tmp28_ = move;
		gee_abstract_list_insert ((GeeAbstractList*) _tmp26_, _tmp27_, _tmp28_);
		plank_items_dock_item_provider_set_item_positions (self);
	} else {
		plank_items_dock_item_provider_update_visible_items (self);
	}
}


void plank_items_dock_item_provider_move_item_to (PlankItemsDockItemProvider* self, PlankItemsDockItem* move, PlankItemsDockItem* target) {
	g_return_if_fail (self != NULL);
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_CLASS (self)->move_item_to (self, move, target);
}


/**
 * Reset internal buffers of all items.
 */
void plank_items_dock_item_provider_reset_item_buffers (PlankItemsDockItemProvider* self) {
	g_return_if_fail (self != NULL);
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp0_ = NULL;
		GeeArrayList* _tmp1_ = NULL;
		gint _item_size = 0;
		GeeArrayList* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _item_index = 0;
		_tmp0_ = self->internal_items;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_item_list = _tmp1_;
		_tmp2_ = _item_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_item_size = _tmp4_;
		_item_index = -1;
		while (TRUE) {
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			PlankItemsDockItem* item = NULL;
			GeeArrayList* _tmp8_ = NULL;
			gint _tmp9_ = 0;
			gpointer _tmp10_ = NULL;
			PlankItemsDockItem* _tmp11_ = NULL;
			_tmp5_ = _item_index;
			_item_index = _tmp5_ + 1;
			_tmp6_ = _item_index;
			_tmp7_ = _item_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _item_list;
			_tmp9_ = _item_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			item = (PlankItemsDockItem*) _tmp10_;
			_tmp11_ = item;
			plank_items_dock_item_reset_buffers (_tmp11_);
			_g_object_unref0 (item);
		}
		_g_object_unref0 (_item_list);
	}
}


static gboolean plank_items_dock_item_provider_real_item_exists_for_uri (PlankItemsDockItemProvider* self, const gchar* uri) {
	gboolean result = FALSE;
	g_return_val_if_fail (uri != NULL, FALSE);
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp0_ = NULL;
		GeeArrayList* _tmp1_ = NULL;
		gint _item_size = 0;
		GeeArrayList* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _item_index = 0;
		_tmp0_ = self->internal_items;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_item_list = _tmp1_;
		_tmp2_ = _item_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_item_size = _tmp4_;
		_item_index = -1;
		while (TRUE) {
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			PlankItemsDockItem* item = NULL;
			GeeArrayList* _tmp8_ = NULL;
			gint _tmp9_ = 0;
			gpointer _tmp10_ = NULL;
			PlankItemsDockItem* _tmp11_ = NULL;
			const gchar* _tmp12_ = NULL;
			const gchar* _tmp13_ = NULL;
			const gchar* _tmp14_ = NULL;
			_tmp5_ = _item_index;
			_item_index = _tmp5_ + 1;
			_tmp6_ = _item_index;
			_tmp7_ = _item_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _item_list;
			_tmp9_ = _item_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			item = (PlankItemsDockItem*) _tmp10_;
			_tmp11_ = item;
			_tmp12_ = plank_items_dock_item_get_Launcher (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = uri;
			if (g_strcmp0 (_tmp13_, _tmp14_) == 0) {
				result = TRUE;
				_g_object_unref0 (item);
				_g_object_unref0 (_item_list);
				return result;
			}
			_g_object_unref0 (item);
		}
		_g_object_unref0 (_item_list);
	}
	result = FALSE;
	return result;
}


gboolean plank_items_dock_item_provider_item_exists_for_uri (PlankItemsDockItemProvider* self, const gchar* uri) {
	g_return_val_if_fail (self != NULL, FALSE);
	return PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_CLASS (self)->item_exists_for_uri (self, uri);
}


static void plank_items_dock_item_provider_real_add_item_with_uri (PlankItemsDockItemProvider* self, const gchar* uri, PlankItemsDockItem* target) {
	g_return_if_fail (uri != NULL);
	g_warning ("DockItemProvider.vala:265: Not implemented by default");
}


void plank_items_dock_item_provider_add_item_with_uri (PlankItemsDockItemProvider* self, const gchar* uri, PlankItemsDockItem* target) {
	g_return_if_fail (self != NULL);
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_CLASS (self)->add_item_with_uri (self, uri, target);
}


static void plank_items_dock_item_provider_real_add_item_without_signaling (PlankItemsDockItemProvider* self, PlankItemsDockItem* item) {
	gboolean _tmp0_ = FALSE;
	PlankItemsDockItem* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean _tmp10_ = FALSE;
	PlankItemsDockItem* _tmp18_ = NULL;
	PlankItemsDockItem* _tmp19_ = NULL;
	GDateTime* _tmp20_ = NULL;
	GDateTime* _tmp21_ = NULL;
	PlankItemsDockItem* _tmp22_ = NULL;
	g_return_if_fail (item != NULL);
	_tmp1_ = item;
	_tmp2_ = plank_items_dock_item_get_Position (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ > (-1)) {
		PlankItemsDockItem* _tmp4_ = NULL;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		GeeArrayList* _tmp7_ = NULL;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		_tmp4_ = item;
		_tmp5_ = plank_items_dock_item_get_Position (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = self->internal_items;
		_tmp8_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp7_);
		_tmp9_ = _tmp8_;
		_tmp0_ = _tmp6_ <= _tmp9_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp10_ = _tmp0_;
	if (_tmp10_) {
		GeeArrayList* _tmp11_ = NULL;
		PlankItemsDockItem* _tmp12_ = NULL;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		PlankItemsDockItem* _tmp15_ = NULL;
		_tmp11_ = self->internal_items;
		_tmp12_ = item;
		_tmp13_ = plank_items_dock_item_get_Position (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = item;
		gee_abstract_list_insert ((GeeAbstractList*) _tmp11_, _tmp14_, _tmp15_);
	} else {
		GeeArrayList* _tmp16_ = NULL;
		PlankItemsDockItem* _tmp17_ = NULL;
		_tmp16_ = self->internal_items;
		_tmp17_ = item;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
	}
	_tmp18_ = item;
	plank_items_dock_item_set_Provider (_tmp18_, self);
	_tmp19_ = item;
	_tmp20_ = g_date_time_new_now_utc ();
	_tmp21_ = _tmp20_;
	plank_items_dock_item_set_AddTime (_tmp19_, _tmp21_);
	_g_date_time_unref0 (_tmp21_);
	_tmp22_ = item;
	plank_items_dock_item_provider_item_signals_connect (self, _tmp22_);
}


void plank_items_dock_item_provider_add_item_without_signaling (PlankItemsDockItemProvider* self, PlankItemsDockItem* item) {
	g_return_if_fail (self != NULL);
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_CLASS (self)->add_item_without_signaling (self, item);
}


/**
 * Replace an item with another item.
 *
 * @param new_item the new item
 * @param old_item the item to be replaced
 */
static void plank_items_dock_item_provider_real_replace_item (PlankItemsDockItemProvider* self, PlankItemsDockItem* new_item, PlankItemsDockItem* old_item) {
	gboolean _tmp0_ = FALSE;
	PlankItemsDockItem* _tmp1_ = NULL;
	PlankItemsDockItem* _tmp2_ = NULL;
	gboolean _tmp6_ = FALSE;
	PlankItemsDockItem* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	PlankItemsDockItem* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	PlankItemsDockItem* _tmp14_ = NULL;
	PlankItemsDockItem* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	PlankItemsDockItem* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	gchar* _tmp21_ = NULL;
	PlankItemsDockItem* _tmp22_ = NULL;
	PlankItemsDockItem* _tmp23_ = NULL;
	gint index = 0;
	GeeArrayList* _tmp24_ = NULL;
	PlankItemsDockItem* _tmp25_ = NULL;
	gint _tmp26_ = 0;
	GeeArrayList* _tmp27_ = NULL;
	PlankItemsDockItem* _tmp28_ = NULL;
	PlankItemsDockItem* _tmp29_ = NULL;
	GeeArrayList* _tmp30_ = NULL;
	gint _tmp31_ = 0;
	PlankItemsDockItem* _tmp32_ = NULL;
	PlankItemsDockItem* _tmp33_ = NULL;
	PlankItemsDockItem* _tmp34_ = NULL;
	PlankItemsDockItem* _tmp35_ = NULL;
	GDateTime* _tmp36_ = NULL;
	GDateTime* _tmp37_ = NULL;
	PlankItemsDockItem* _tmp38_ = NULL;
	PlankItemsDockItem* _tmp39_ = NULL;
	gint _tmp40_ = 0;
	gint _tmp41_ = 0;
	PlankItemsDockItem* _tmp42_ = NULL;
	GeeArrayList* _tmp43_ = NULL;
	PlankItemsDockItem* _tmp44_ = NULL;
	gint _tmp45_ = 0;
	gint _tmp46_ = 0;
	g_return_if_fail (new_item != NULL);
	g_return_if_fail (old_item != NULL);
	_tmp1_ = new_item;
	_tmp2_ = old_item;
	if (_tmp1_ == _tmp2_) {
		_tmp0_ = TRUE;
	} else {
		GeeArrayList* _tmp3_ = NULL;
		PlankItemsDockItem* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
		_tmp3_ = self->internal_items;
		_tmp4_ = old_item;
		_tmp5_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp3_, _tmp4_);
		_tmp0_ = !_tmp5_;
	}
	_tmp6_ = _tmp0_;
	if (_tmp6_) {
		return;
	}
	_tmp7_ = old_item;
	_tmp8_ = plank_items_dock_item_get_Text (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = old_item;
	_tmp11_ = plank_items_dock_item_get_DockItemFilename (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = _tmp12_;
	_tmp14_ = old_item;
	_tmp15_ = new_item;
	_tmp16_ = plank_items_dock_item_get_Text (_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = new_item;
	_tmp19_ = plank_items_dock_item_get_DockItemFilename (_tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = _tmp20_;
	_tmp22_ = new_item;
	plank_services_logger_verbose ("DockItemProvider.replace_item (%s[%s, %i] > %s[%s, %i])", _tmp9_, _tmp13_, (gint) _tmp14_, _tmp17_, _tmp21_, (gint) _tmp22_, NULL);
	_g_free0 (_tmp21_);
	_g_free0 (_tmp13_);
	_tmp23_ = old_item;
	plank_items_dock_item_provider_item_signals_disconnect (self, _tmp23_);
	_tmp24_ = self->internal_items;
	_tmp25_ = old_item;
	_tmp26_ = gee_abstract_list_index_of ((GeeAbstractList*) _tmp24_, _tmp25_);
	index = _tmp26_;
	_tmp27_ = self->internal_items;
	_tmp28_ = old_item;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp27_, _tmp28_);
	_tmp29_ = old_item;
	plank_items_dock_item_set_Provider (_tmp29_, NULL);
	_tmp30_ = self->internal_items;
	_tmp31_ = index;
	_tmp32_ = new_item;
	gee_abstract_list_insert ((GeeAbstractList*) _tmp30_, _tmp31_, _tmp32_);
	_tmp33_ = new_item;
	plank_items_dock_item_set_Provider (_tmp33_, self);
	_tmp34_ = new_item;
	_tmp35_ = old_item;
	_tmp36_ = plank_items_dock_item_get_AddTime (_tmp35_);
	_tmp37_ = _tmp36_;
	plank_items_dock_item_set_AddTime (_tmp34_, _tmp37_);
	_tmp38_ = new_item;
	_tmp39_ = old_item;
	_tmp40_ = plank_items_dock_item_get_Position (_tmp39_);
	_tmp41_ = _tmp40_;
	plank_items_dock_item_set_Position (_tmp38_, _tmp41_);
	_tmp42_ = new_item;
	plank_items_dock_item_provider_item_signals_connect (self, _tmp42_);
	_tmp43_ = self->visible_items;
	_tmp44_ = old_item;
	_tmp45_ = gee_abstract_list_index_of ((GeeAbstractList*) _tmp43_, _tmp44_);
	index = _tmp45_;
	_tmp46_ = index;
	if (_tmp46_ >= 0) {
		GeeArrayList* _tmp47_ = NULL;
		PlankItemsDockItem* _tmp48_ = NULL;
		GeeArrayList* _tmp49_ = NULL;
		gint _tmp50_ = 0;
		PlankItemsDockItem* _tmp51_ = NULL;
		_tmp47_ = self->visible_items;
		_tmp48_ = old_item;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp47_, _tmp48_);
		_tmp49_ = self->visible_items;
		_tmp50_ = index;
		_tmp51_ = new_item;
		gee_abstract_list_insert ((GeeAbstractList*) _tmp49_, _tmp50_, _tmp51_);
	} else {
		plank_items_dock_item_provider_update_visible_items (self);
	}
}


void plank_items_dock_item_provider_replace_item (PlankItemsDockItemProvider* self, PlankItemsDockItem* new_item, PlankItemsDockItem* old_item) {
	g_return_if_fail (self != NULL);
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_CLASS (self)->replace_item (self, new_item, old_item);
}


static void plank_items_dock_item_provider_real_remove_item_without_signaling (PlankItemsDockItemProvider* self, PlankItemsDockItem* item) {
	PlankItemsDockItem* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
	GDateTime* _tmp2_ = NULL;
	PlankItemsDockItem* _tmp3_ = NULL;
	GeeArrayList* _tmp4_ = NULL;
	PlankItemsDockItem* _tmp5_ = NULL;
	PlankItemsDockItem* _tmp6_ = NULL;
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = g_date_time_new_now_utc ();
	_tmp2_ = _tmp1_;
	plank_items_dock_item_set_RemoveTime (_tmp0_, _tmp2_);
	_g_date_time_unref0 (_tmp2_);
	_tmp3_ = item;
	plank_items_dock_item_provider_item_signals_disconnect (self, _tmp3_);
	_tmp4_ = self->internal_items;
	_tmp5_ = item;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp4_, _tmp5_);
	_tmp6_ = item;
	plank_items_dock_item_set_Provider (_tmp6_, NULL);
}


void plank_items_dock_item_provider_remove_item_without_signaling (PlankItemsDockItemProvider* self, PlankItemsDockItem* item) {
	g_return_if_fail (self != NULL);
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_CLASS (self)->remove_item_without_signaling (self, item);
}


static void _plank_items_dock_item_provider_handle_item_state_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	plank_items_dock_item_provider_handle_item_state_changed (self);
}


static void _plank_items_dock_item_provider_handle_item_state_changed_plank_items_dock_item_needs_redraw (PlankItemsDockItem* _sender, gpointer self) {
	plank_items_dock_item_provider_handle_item_state_changed (self);
}


static void _plank_items_dock_item_provider_handle_item_deleted_plank_items_dock_item_deleted (PlankItemsDockItem* _sender, gpointer self) {
	plank_items_dock_item_provider_handle_item_deleted (self, _sender);
}


static void plank_items_dock_item_provider_real_item_signals_connect (PlankItemsDockItemProvider* self, PlankItemsDockItem* item) {
	PlankItemsDockItem* _tmp0_ = NULL;
	PlankItemsDockItem* _tmp1_ = NULL;
	PlankItemsDockItem* _tmp2_ = NULL;
	PlankItemsDockItem* _tmp3_ = NULL;
	PlankItemsDockItem* _tmp4_ = NULL;
	PlankItemsDockItem* _tmp5_ = NULL;
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	g_signal_connect_object ((GObject*) _tmp0_, "notify::Icon", (GCallback) _plank_items_dock_item_provider_handle_item_state_changed_g_object_notify, self, 0);
	_tmp1_ = item;
	g_signal_connect_object ((GObject*) _tmp1_, "notify::Indicator", (GCallback) _plank_items_dock_item_provider_handle_item_state_changed_g_object_notify, self, 0);
	_tmp2_ = item;
	g_signal_connect_object ((GObject*) _tmp2_, "notify::State", (GCallback) _plank_items_dock_item_provider_handle_item_state_changed_g_object_notify, self, 0);
	_tmp3_ = item;
	g_signal_connect_object ((GObject*) _tmp3_, "notify::LastClicked", (GCallback) _plank_items_dock_item_provider_handle_item_state_changed_g_object_notify, self, 0);
	_tmp4_ = item;
	g_signal_connect_object (_tmp4_, "needs-redraw", (GCallback) _plank_items_dock_item_provider_handle_item_state_changed_plank_items_dock_item_needs_redraw, self, 0);
	_tmp5_ = item;
	g_signal_connect_object (_tmp5_, "deleted", (GCallback) _plank_items_dock_item_provider_handle_item_deleted_plank_items_dock_item_deleted, self, 0);
}


void plank_items_dock_item_provider_item_signals_connect (PlankItemsDockItemProvider* self, PlankItemsDockItem* item) {
	g_return_if_fail (self != NULL);
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_CLASS (self)->item_signals_connect (self, item);
}


static void plank_items_dock_item_provider_real_item_signals_disconnect (PlankItemsDockItemProvider* self, PlankItemsDockItem* item) {
	PlankItemsDockItem* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	GQuark _tmp2_ = 0U;
	PlankItemsDockItem* _tmp3_ = NULL;
	guint _tmp4_ = 0U;
	GQuark _tmp5_ = 0U;
	PlankItemsDockItem* _tmp6_ = NULL;
	guint _tmp7_ = 0U;
	GQuark _tmp8_ = 0U;
	PlankItemsDockItem* _tmp9_ = NULL;
	guint _tmp10_ = 0U;
	GQuark _tmp11_ = 0U;
	PlankItemsDockItem* _tmp12_ = NULL;
	guint _tmp13_ = 0U;
	PlankItemsDockItem* _tmp14_ = NULL;
	guint _tmp15_ = 0U;
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	g_signal_parse_name ("notify::Icon", G_TYPE_OBJECT, &_tmp1_, &_tmp2_, TRUE);
	g_signal_handlers_disconnect_matched ((GObject*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, _tmp2_, NULL, (GCallback) _plank_items_dock_item_provider_handle_item_state_changed_g_object_notify, self);
	_tmp3_ = item;
	g_signal_parse_name ("notify::Indicator", G_TYPE_OBJECT, &_tmp4_, &_tmp5_, TRUE);
	g_signal_handlers_disconnect_matched ((GObject*) _tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, _tmp5_, NULL, (GCallback) _plank_items_dock_item_provider_handle_item_state_changed_g_object_notify, self);
	_tmp6_ = item;
	g_signal_parse_name ("notify::State", G_TYPE_OBJECT, &_tmp7_, &_tmp8_, TRUE);
	g_signal_handlers_disconnect_matched ((GObject*) _tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, _tmp8_, NULL, (GCallback) _plank_items_dock_item_provider_handle_item_state_changed_g_object_notify, self);
	_tmp9_ = item;
	g_signal_parse_name ("notify::LastClicked", G_TYPE_OBJECT, &_tmp10_, &_tmp11_, TRUE);
	g_signal_handlers_disconnect_matched ((GObject*) _tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, _tmp11_, NULL, (GCallback) _plank_items_dock_item_provider_handle_item_state_changed_g_object_notify, self);
	_tmp12_ = item;
	g_signal_parse_name ("needs-redraw", PLANK_ITEMS_TYPE_DOCK_ITEM, &_tmp13_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _plank_items_dock_item_provider_handle_item_state_changed_plank_items_dock_item_needs_redraw, self);
	_tmp14_ = item;
	g_signal_parse_name ("deleted", PLANK_ITEMS_TYPE_DOCK_ITEM, &_tmp15_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _plank_items_dock_item_provider_handle_item_deleted_plank_items_dock_item_deleted, self);
}


void plank_items_dock_item_provider_item_signals_disconnect (PlankItemsDockItemProvider* self, PlankItemsDockItem* item) {
	g_return_if_fail (self != NULL);
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_CLASS (self)->item_signals_disconnect (self, item);
}


static void plank_items_dock_item_provider_real_handle_item_deleted (PlankItemsDockItemProvider* self, PlankItemsDockItem* item) {
	PlankItemsDockItem* _tmp0_ = NULL;
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	plank_items_dock_item_provider_remove_item (self, _tmp0_);
}


void plank_items_dock_item_provider_handle_item_deleted (PlankItemsDockItemProvider* self, PlankItemsDockItem* item) {
	g_return_if_fail (self != NULL);
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_CLASS (self)->handle_item_deleted (self, item);
}


/**
 * Returns if the provider accepts a drop of the given URIs.
 *
 * @param uris the URIs to check
 * @return if the provider accepts a drop of the given URIs
 */
static gboolean plank_items_dock_item_provider_real_can_accept_drop (PlankItemsDockItemProvider* self, GeeArrayList* uris) {
	gboolean result = FALSE;
	g_return_val_if_fail (uris != NULL, FALSE);
	result = FALSE;
	return result;
}


gboolean plank_items_dock_item_provider_can_accept_drop (PlankItemsDockItemProvider* self, GeeArrayList* uris) {
	g_return_val_if_fail (self != NULL, FALSE);
	return PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_CLASS (self)->can_accept_drop (self, uris);
}


/**
 * Accepts a drop of the given URIs.
 *
 * @param uris the URIs to accept
 * @return if the item accepted a drop of the given URIs
 */
static gboolean plank_items_dock_item_provider_real_accept_drop (PlankItemsDockItemProvider* self, GeeArrayList* uris) {
	gboolean result = FALSE;
	g_return_val_if_fail (uris != NULL, FALSE);
	result = FALSE;
	return result;
}


gboolean plank_items_dock_item_provider_accept_drop (PlankItemsDockItemProvider* self, GeeArrayList* uris) {
	g_return_val_if_fail (self != NULL, FALSE);
	return PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_CLASS (self)->accept_drop (self, uris);
}


gint plank_items_dock_item_provider_compare_items (PlankItemsDockItem* left, PlankItemsDockItem* right) {
	gint result = 0;
	PlankItemsDockItem* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	PlankItemsDockItem* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	PlankItemsDockItem* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	PlankItemsDockItem* _tmp9_ = NULL;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	g_return_val_if_fail (left != NULL, 0);
	g_return_val_if_fail (right != NULL, 0);
	_tmp0_ = left;
	_tmp1_ = plank_items_dock_item_get_Position (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = right;
	_tmp4_ = plank_items_dock_item_get_Position (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp2_ == _tmp5_) {
		result = 0;
		return result;
	}
	_tmp6_ = left;
	_tmp7_ = plank_items_dock_item_get_Position (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = right;
	_tmp10_ = plank_items_dock_item_get_Position (_tmp9_);
	_tmp11_ = _tmp10_;
	if (_tmp8_ < _tmp11_) {
		result = -1;
		return result;
	}
	result = 1;
	return result;
}


GeeArrayList* plank_items_dock_item_provider_get_Items (PlankItemsDockItemProvider* self) {
	GeeArrayList* result;
	GeeArrayList* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->visible_items;
	result = _tmp0_;
	return result;
}


gint plank_items_dock_item_provider_get_FirstItemPosition (PlankItemsDockItemProvider* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->first_item_position;
	result = _tmp0_;
	return result;
}


void plank_items_dock_item_provider_set_FirstItemPosition (PlankItemsDockItemProvider* self, gint value) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->first_item_position;
	_tmp1_ = value;
	if (_tmp0_ == _tmp1_) {
		return;
	}
	_tmp2_ = value;
	self->priv->first_item_position = _tmp2_;
	plank_items_dock_item_provider_set_item_positions (self);
	g_object_notify ((GObject *) self, "FirstItemPosition");
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static GObject * plank_items_dock_item_provider_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	PlankItemsDockItemProvider * self;
	GeeArrayList* _tmp0_ = NULL;
	GeeArrayList* _tmp1_ = NULL;
	GeeHashMap* _tmp2_ = NULL;
	parent_class = G_OBJECT_CLASS (plank_items_dock_item_provider_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER, PlankItemsDockItemProvider);
	_tmp0_ = gee_array_list_new (PLANK_ITEMS_TYPE_DOCK_ITEM, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->visible_items);
	self->visible_items = _tmp0_;
	_tmp1_ = gee_array_list_new (PLANK_ITEMS_TYPE_DOCK_ITEM, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->internal_items);
	self->internal_items = _tmp1_;
	_tmp2_ = gee_hash_map_new (PLANK_ITEMS_TYPE_DOCK_ITEM, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->saved_item_positions);
	self->saved_item_positions = (GeeMap*) _tmp2_;
	return obj;
}


static void plank_items_dock_item_provider_class_init (PlankItemsDockItemProviderClass * klass) {
	plank_items_dock_item_provider_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PlankItemsDockItemProviderPrivate));
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_CLASS (klass)->update_visible_items = plank_items_dock_item_provider_real_update_visible_items;
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_CLASS (klass)->move_item_to = plank_items_dock_item_provider_real_move_item_to;
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_CLASS (klass)->item_exists_for_uri = plank_items_dock_item_provider_real_item_exists_for_uri;
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_CLASS (klass)->add_item_with_uri = plank_items_dock_item_provider_real_add_item_with_uri;
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_CLASS (klass)->add_item_without_signaling = plank_items_dock_item_provider_real_add_item_without_signaling;
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_CLASS (klass)->replace_item = plank_items_dock_item_provider_real_replace_item;
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_CLASS (klass)->remove_item_without_signaling = plank_items_dock_item_provider_real_remove_item_without_signaling;
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_CLASS (klass)->item_signals_connect = plank_items_dock_item_provider_real_item_signals_connect;
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_CLASS (klass)->item_signals_disconnect = plank_items_dock_item_provider_real_item_signals_disconnect;
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_CLASS (klass)->handle_item_deleted = plank_items_dock_item_provider_real_handle_item_deleted;
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_CLASS (klass)->can_accept_drop = plank_items_dock_item_provider_real_can_accept_drop;
	PLANK_ITEMS_DOCK_ITEM_PROVIDER_CLASS (klass)->accept_drop = plank_items_dock_item_provider_real_accept_drop;
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_items_dock_item_provider_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_items_dock_item_provider_set_property;
	G_OBJECT_CLASS (klass)->constructor = plank_items_dock_item_provider_constructor;
	G_OBJECT_CLASS (klass)->finalize = plank_items_dock_item_provider_finalize;
	/**
	 * A list of the dock items.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ITEM_PROVIDER_ITEMS, g_param_spec_object ("Items", "Items", "Items", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	 * The absolute position of the first item of this provider on the dock.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ITEM_PROVIDER_FIRST_ITEM_POSITION, g_param_spec_int ("FirstItemPosition", "FirstItemPosition", "FirstItemPosition", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * Triggered when the items collection has changed.
	 *
	 * @param added the list of added items
	 * @param removed the list of removed items
	 */
	g_signal_new ("items_changed", PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_LIST, GEE_TYPE_LIST);
	/**
	 * Triggered when the state of an item changes.
	 */
	g_signal_new ("item_state_changed", PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/**
	 * Triggered anytime an item's Position was changed.
	 */
	g_signal_new ("item_position_changed", PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, PLANK_ITEMS_TYPE_DOCK_ITEM);
}


static void plank_items_dock_item_provider_instance_init (PlankItemsDockItemProvider * self) {
	self->priv = PLANK_ITEMS_DOCK_ITEM_PROVIDER_GET_PRIVATE (self);
	self->priv->first_item_position = 0;
}


static void plank_items_dock_item_provider_finalize (GObject* obj) {
	PlankItemsDockItemProvider * self;
	GeeMap* _tmp0_ = NULL;
	GeeArrayList* _tmp1_ = NULL;
	GeeHashSet* items = NULL;
	GeeHashSet* _tmp2_ = NULL;
	GeeHashSet* _tmp3_ = NULL;
	GeeArrayList* _tmp4_ = NULL;
	GeeArrayList* _tmp13_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER, PlankItemsDockItemProvider);
	_tmp0_ = self->saved_item_positions;
	gee_map_clear (_tmp0_);
	_tmp1_ = self->visible_items;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
	_tmp2_ = gee_hash_set_new (PLANK_ITEMS_TYPE_DOCK_ITEM, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	items = _tmp2_;
	_tmp3_ = items;
	_tmp4_ = self->internal_items;
	gee_collection_add_all ((GeeCollection*) _tmp3_, (GeeCollection*) _tmp4_);
	{
		GeeIterator* _item_it = NULL;
		GeeHashSet* _tmp5_ = NULL;
		GeeIterator* _tmp6_ = NULL;
		_tmp5_ = items;
		_tmp6_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp5_);
		_item_it = _tmp6_;
		while (TRUE) {
			GeeIterator* _tmp7_ = NULL;
			gboolean _tmp8_ = FALSE;
			PlankItemsDockItem* item = NULL;
			GeeIterator* _tmp9_ = NULL;
			gpointer _tmp10_ = NULL;
			PlankItemsDockItem* _tmp11_ = NULL;
			PlankItemsDockItem* _tmp12_ = NULL;
			_tmp7_ = _item_it;
			_tmp8_ = gee_iterator_next (_tmp7_);
			if (!_tmp8_) {
				break;
			}
			_tmp9_ = _item_it;
			_tmp10_ = gee_iterator_get (_tmp9_);
			item = (PlankItemsDockItem*) _tmp10_;
			_tmp11_ = item;
			plank_items_dock_item_provider_remove_item_without_signaling (self, _tmp11_);
			_tmp12_ = item;
			plank_items_dock_item_set_Provider (_tmp12_, NULL);
			_g_object_unref0 (item);
		}
		_g_object_unref0 (_item_it);
	}
	_tmp13_ = self->internal_items;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp13_);
	_g_object_unref0 (items);
	_g_object_unref0 (self->visible_items);
	_g_object_unref0 (self->internal_items);
	_g_object_unref0 (self->saved_item_positions);
	G_OBJECT_CLASS (plank_items_dock_item_provider_parent_class)->finalize (obj);
}


/**
 * A container and controller class for managing dock items on a dock.
 */
GType plank_items_dock_item_provider_get_type (void) {
	static volatile gsize plank_items_dock_item_provider_type_id__volatile = 0;
	if (g_once_init_enter (&plank_items_dock_item_provider_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankItemsDockItemProviderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_items_dock_item_provider_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankItemsDockItemProvider), 0, (GInstanceInitFunc) plank_items_dock_item_provider_instance_init, NULL };
		GType plank_items_dock_item_provider_type_id;
		plank_items_dock_item_provider_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankItemsDockItemProvider", &g_define_type_info, 0);
		g_once_init_leave (&plank_items_dock_item_provider_type_id__volatile, plank_items_dock_item_provider_type_id);
	}
	return plank_items_dock_item_provider_type_id__volatile;
}


static void _vala_plank_items_dock_item_provider_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PlankItemsDockItemProvider * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER, PlankItemsDockItemProvider);
	switch (property_id) {
		case PLANK_ITEMS_DOCK_ITEM_PROVIDER_ITEMS:
		g_value_set_object (value, plank_items_dock_item_provider_get_Items (self));
		break;
		case PLANK_ITEMS_DOCK_ITEM_PROVIDER_FIRST_ITEM_POSITION:
		g_value_set_int (value, plank_items_dock_item_provider_get_FirstItemPosition (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_plank_items_dock_item_provider_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PlankItemsDockItemProvider * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_ITEMS_TYPE_DOCK_ITEM_PROVIDER, PlankItemsDockItemProvider);
	switch (property_id) {
		case PLANK_ITEMS_DOCK_ITEM_PROVIDER_FIRST_ITEM_POSITION:
		plank_items_dock_item_provider_set_FirstItemPosition (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



