/* WindowControl.c generated by valac 0.22.1, the Vala compiler
 * generated from WindowControl.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <libwnck/libwnck.h>
#include <libbamf/libbamf.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <gtk/gtk.h>
#include <string.h>


#define PLANK_SERVICES_WINDOWS_TYPE_STRUTS (plank_services_windows_struts_get_type ())

#define PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL (plank_services_windows_window_control_get_type ())
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL, PlankServicesWindowsWindowControl))
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL, PlankServicesWindowsWindowControlClass))
#define PLANK_SERVICES_WINDOWS_IS_WINDOW_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL))
#define PLANK_SERVICES_WINDOWS_IS_WINDOW_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL))
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL, PlankServicesWindowsWindowControlClass))

typedef struct _PlankServicesWindowsWindowControl PlankServicesWindowsWindowControl;
typedef struct _PlankServicesWindowsWindowControlClass PlankServicesWindowsWindowControlClass;
typedef struct _PlankServicesWindowsWindowControlPrivate PlankServicesWindowsWindowControlPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
typedef struct _Block1Data Block1Data;

typedef enum  {
	PLANK_SERVICES_WINDOWS_STRUTS_LEFT,
	PLANK_SERVICES_WINDOWS_STRUTS_RIGHT,
	PLANK_SERVICES_WINDOWS_STRUTS_TOP,
	PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM,
	PLANK_SERVICES_WINDOWS_STRUTS_LEFT_START,
	PLANK_SERVICES_WINDOWS_STRUTS_LEFT_END,
	PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_START,
	PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_END,
	PLANK_SERVICES_WINDOWS_STRUTS_TOP_START,
	PLANK_SERVICES_WINDOWS_STRUTS_TOP_END,
	PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_START,
	PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_END,
	PLANK_SERVICES_WINDOWS_STRUTS_N_VALUES
} PlankServicesWindowsStruts;

struct _PlankServicesWindowsWindowControl {
	GObject parent_instance;
	PlankServicesWindowsWindowControlPrivate * priv;
};

struct _PlankServicesWindowsWindowControlClass {
	GObjectClass parent_class;
};

struct _Block1Data {
	int _ref_count_;
	guint32 time;
	WnckWindow* targetWindow;
};


static gpointer plank_services_windows_window_control_parent_class = NULL;

GType plank_services_windows_struts_get_type (void) G_GNUC_CONST;
GType plank_services_windows_window_control_get_type (void) G_GNUC_CONST;
enum  {
	PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_DUMMY_PROPERTY
};
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY ((guint) 10000)
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY ((guint) 200)
static PlankServicesWindowsWindowControl* plank_services_windows_window_control_new (void);
static PlankServicesWindowsWindowControl* plank_services_windows_window_control_construct (GType object_type);
void plank_services_windows_window_control_initialize (void);
static void plank_services_windows_window_control_window_manager_changed (WnckScreen* screen);
static void _plank_services_windows_window_control_window_manager_changed_wnck_screen_window_manager_changed (WnckScreen* _sender, gpointer self);
GdkPixbuf* plank_services_windows_window_control_get_app_icon (BamfApplication* app);
GdkPixbuf* plank_services_windows_window_control_get_window_icon (BamfWindow* window);
guint plank_services_windows_window_control_get_num_windows (BamfApplication* app);
gboolean plank_services_windows_window_control_has_maximized_window (BamfApplication* app);
gboolean plank_services_windows_window_control_has_minimized_window (BamfApplication* app);
gboolean plank_services_windows_window_control_has_window_on_workspace (BamfApplication* app, WnckWorkspace* workspace);
GeeArrayList* plank_services_windows_window_control_get_windows (BamfApplication* app);
void plank_services_windows_window_control_update_icon_regions (BamfApplication* app, GdkRectangle* rect);
void plank_services_windows_window_control_close_all (BamfApplication* app);
void plank_services_windows_window_control_focus_window (BamfWindow* window);
static void plank_services_windows_window_control_center_and_focus_window (WnckWindow* w);
void plank_services_windows_window_control_focus_window_by_xid (guint32 xid);
void plank_services_windows_window_control_focus (BamfApplication* app);
GeeArrayList* plank_services_windows_window_control_get_ordered_window_stack (BamfApplication* app);
static gint plank_services_windows_window_control_find_active_xid_index (GArray* xids);
void plank_services_windows_window_control_focus_previous (BamfApplication* app);
void plank_services_windows_window_control_focus_next (BamfApplication* app);
void plank_services_windows_window_control_minimize (BamfApplication* app);
void plank_services_windows_window_control_restore (BamfApplication* app);
void plank_services_windows_window_control_maximize (BamfApplication* app);
void plank_services_windows_window_control_unmaximize (BamfApplication* app);
void plank_services_windows_window_control_smart_focus (BamfApplication* app);
static void plank_services_windows_window_control_intelligent_focus_off_viewport_window (WnckWindow* targetWindow, GeeArrayList* additional_windows);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean plank_services_windows_window_control_windows_share_viewport (WnckWindow* first, WnckWindow* second);
static gboolean __lambda2_ (Block1Data* _data1_);
static gboolean ___lambda2__gsource_func (gpointer self);
void plank_services_windows_window_control_get_easy_geometry (WnckWindow* w, GdkRectangle* result);


GType plank_services_windows_struts_get_type (void) {
	static volatile gsize plank_services_windows_struts_type_id__volatile = 0;
	if (g_once_init_enter (&plank_services_windows_struts_type_id__volatile)) {
		static const GEnumValue values[] = {{PLANK_SERVICES_WINDOWS_STRUTS_LEFT, "PLANK_SERVICES_WINDOWS_STRUTS_LEFT", "left"}, {PLANK_SERVICES_WINDOWS_STRUTS_RIGHT, "PLANK_SERVICES_WINDOWS_STRUTS_RIGHT", "right"}, {PLANK_SERVICES_WINDOWS_STRUTS_TOP, "PLANK_SERVICES_WINDOWS_STRUTS_TOP", "top"}, {PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM, "PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM", "bottom"}, {PLANK_SERVICES_WINDOWS_STRUTS_LEFT_START, "PLANK_SERVICES_WINDOWS_STRUTS_LEFT_START", "left-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_LEFT_END, "PLANK_SERVICES_WINDOWS_STRUTS_LEFT_END", "left-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_START, "PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_START", "right-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_END, "PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_END", "right-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_TOP_START, "PLANK_SERVICES_WINDOWS_STRUTS_TOP_START", "top-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_TOP_END, "PLANK_SERVICES_WINDOWS_STRUTS_TOP_END", "top-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_START, "PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_START", "bottom-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_END, "PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_END", "bottom-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_N_VALUES, "PLANK_SERVICES_WINDOWS_STRUTS_N_VALUES", "n-values"}, {0, NULL, NULL}};
		GType plank_services_windows_struts_type_id;
		plank_services_windows_struts_type_id = g_enum_register_static ("PlankServicesWindowsStruts", values);
		g_once_init_leave (&plank_services_windows_struts_type_id__volatile, plank_services_windows_struts_type_id);
	}
	return plank_services_windows_struts_type_id__volatile;
}


static PlankServicesWindowsWindowControl* plank_services_windows_window_control_construct (GType object_type) {
	PlankServicesWindowsWindowControl * self = NULL;
	self = (PlankServicesWindowsWindowControl*) g_object_new (object_type, NULL);
	return self;
}


static PlankServicesWindowsWindowControl* plank_services_windows_window_control_new (void) {
	return plank_services_windows_window_control_construct (PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _plank_services_windows_window_control_window_manager_changed_wnck_screen_window_manager_changed (WnckScreen* _sender, gpointer self) {
	plank_services_windows_window_control_window_manager_changed (_sender);
}


void plank_services_windows_window_control_initialize (void) {
	WnckScreen* screen = NULL;
	WnckScreen* _tmp0_ = NULL;
	WnckScreen* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	_tmp0_ = wnck_screen_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	screen = _tmp1_;
	wnck_set_client_type (WNCK_CLIENT_TYPE_PAGER);
	wnck_screen_force_update (screen);
	g_signal_connect (screen, "window-manager-changed", (GCallback) _plank_services_windows_window_control_window_manager_changed_wnck_screen_window_manager_changed, NULL);
	_tmp2_ = wnck_screen_get_window_manager_name (screen);
	g_message ("WindowControl.vala:61: Window-manager: %s", _tmp2_);
	_g_object_unref0 (screen);
}


static void plank_services_windows_window_control_window_manager_changed (WnckScreen* screen) {
	WnckScreen* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_if_fail (screen != NULL);
	_tmp0_ = screen;
	_tmp1_ = wnck_screen_get_window_manager_name (_tmp0_);
	g_warning ("WindowControl.vala:66: Window-manager changed: %s", _tmp1_);
}


GdkPixbuf* plank_services_windows_window_control_get_app_icon (BamfApplication* app) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GdkPixbuf* _tmp23_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	pbuf = NULL;
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				GArray* _tmp8_ = NULL;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp14_ = FALSE;
				WnckWindow* window = NULL;
				GArray* _tmp15_ = NULL;
				gint _tmp16_ = 0;
				guint32 _tmp17_ = 0U;
				WnckWindow* _tmp18_ = NULL;
				WnckWindow* _tmp19_ = NULL;
				WnckWindow* _tmp20_ = NULL;
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					gint _tmp5_ = 0;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp8_ = xids;
				if (_tmp8_ != NULL) {
					gint _tmp9_ = 0;
					GArray* _tmp10_ = NULL;
					guint _tmp11_ = 0U;
					_tmp9_ = i;
					_tmp10_ = xids;
					_tmp11_ = _tmp10_->len;
					_tmp7_ = ((guint) _tmp9_) < _tmp11_;
				} else {
					_tmp7_ = FALSE;
				}
				_tmp12_ = _tmp7_;
				if (_tmp12_) {
					GdkPixbuf* _tmp13_ = NULL;
					_tmp13_ = pbuf;
					_tmp6_ = _tmp13_ == NULL;
				} else {
					_tmp6_ = FALSE;
				}
				_tmp14_ = _tmp6_;
				if (!_tmp14_) {
					break;
				}
				_tmp15_ = xids;
				_tmp16_ = i;
				_tmp17_ = g_array_index (_tmp15_, guint32, (guint) _tmp16_);
				_tmp18_ = wnck_window_get ((gulong) _tmp17_);
				_tmp19_ = _g_object_ref0 (_tmp18_);
				window = _tmp19_;
				_tmp20_ = window;
				if (_tmp20_ != NULL) {
					WnckWindow* _tmp21_ = NULL;
					GdkPixbuf* _tmp22_ = NULL;
					_tmp21_ = window;
					_tmp22_ = wnck_window_get_icon (_tmp21_);
					pbuf = _tmp22_;
				}
				_g_object_unref0 (window);
			}
		}
	}
	_tmp23_ = pbuf;
	result = _tmp23_;
	_g_array_unref0 (xids);
	return result;
}


GdkPixbuf* plank_services_windows_window_control_get_window_icon (BamfWindow* window) {
	GdkPixbuf* result = NULL;
	WnckWindow* w = NULL;
	BamfWindow* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	WnckWindow* _tmp2_ = NULL;
	WnckWindow* _tmp3_ = NULL;
	WnckWindow* _tmp4_ = NULL;
	WnckWindow* _tmp5_ = NULL;
	WnckWindow* _tmp6_ = NULL;
	GdkPixbuf* _tmp7_ = NULL;
	g_return_val_if_fail (window != NULL, NULL);
	_tmp0_ = window;
	_tmp1_ = bamf_window_get_xid (_tmp0_);
	_tmp2_ = wnck_window_get ((gulong) _tmp1_);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	w = _tmp3_;
	_tmp4_ = w;
	g_warn_if_fail (_tmp4_ != NULL);
	_tmp5_ = w;
	if (_tmp5_ == NULL) {
		result = NULL;
		_g_object_unref0 (w);
		return result;
	}
	_tmp6_ = w;
	_tmp7_ = wnck_window_get_icon (_tmp6_);
	result = _tmp7_;
	_g_object_unref0 (w);
	return result;
}


guint plank_services_windows_window_control_get_num_windows (BamfApplication* app) {
	guint result = 0U;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GArray* _tmp3_ = NULL;
	GArray* _tmp4_ = NULL;
	guint _tmp5_ = 0U;
	g_return_val_if_fail (app != NULL, 0U);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = xids;
	if (_tmp3_ == NULL) {
		result = (guint) 0;
		_g_array_unref0 (xids);
		return result;
	}
	_tmp4_ = xids;
	_tmp5_ = _tmp4_->len;
	result = _tmp5_;
	_g_array_unref0 (xids);
	return result;
}


gboolean plank_services_windows_window_control_has_maximized_window (BamfApplication* app) {
	gboolean result = FALSE;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_val_if_fail (app != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_ = NULL;
				gboolean _tmp11_ = FALSE;
				WnckWindow* window = NULL;
				GArray* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				WnckWindow* _tmp16_ = NULL;
				gboolean _tmp17_ = FALSE;
				WnckWindow* _tmp18_ = NULL;
				gboolean _tmp21_ = FALSE;
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					gint _tmp5_ = 0;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp7_ = xids;
				if (_tmp7_ != NULL) {
					gint _tmp8_ = 0;
					GArray* _tmp9_ = NULL;
					guint _tmp10_ = 0U;
					_tmp8_ = i;
					_tmp9_ = xids;
					_tmp10_ = _tmp9_->len;
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
				} else {
					_tmp6_ = FALSE;
				}
				_tmp11_ = _tmp6_;
				if (!_tmp11_) {
					break;
				}
				_tmp12_ = xids;
				_tmp13_ = i;
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
				_tmp16_ = _g_object_ref0 (_tmp15_);
				window = _tmp16_;
				_tmp18_ = window;
				if (_tmp18_ != NULL) {
					WnckWindow* _tmp19_ = NULL;
					gboolean _tmp20_ = FALSE;
					_tmp19_ = window;
					_tmp20_ = wnck_window_is_maximized (_tmp19_);
					_tmp17_ = _tmp20_;
				} else {
					_tmp17_ = FALSE;
				}
				_tmp21_ = _tmp17_;
				if (_tmp21_) {
					result = TRUE;
					_g_object_unref0 (window);
					_g_array_unref0 (xids);
					return result;
				}
				_g_object_unref0 (window);
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


gboolean plank_services_windows_window_control_has_minimized_window (BamfApplication* app) {
	gboolean result = FALSE;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_val_if_fail (app != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_ = NULL;
				gboolean _tmp11_ = FALSE;
				WnckWindow* window = NULL;
				GArray* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				WnckWindow* _tmp16_ = NULL;
				gboolean _tmp17_ = FALSE;
				WnckWindow* _tmp18_ = NULL;
				gboolean _tmp21_ = FALSE;
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					gint _tmp5_ = 0;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp7_ = xids;
				if (_tmp7_ != NULL) {
					gint _tmp8_ = 0;
					GArray* _tmp9_ = NULL;
					guint _tmp10_ = 0U;
					_tmp8_ = i;
					_tmp9_ = xids;
					_tmp10_ = _tmp9_->len;
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
				} else {
					_tmp6_ = FALSE;
				}
				_tmp11_ = _tmp6_;
				if (!_tmp11_) {
					break;
				}
				_tmp12_ = xids;
				_tmp13_ = i;
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
				_tmp16_ = _g_object_ref0 (_tmp15_);
				window = _tmp16_;
				_tmp18_ = window;
				if (_tmp18_ != NULL) {
					WnckWindow* _tmp19_ = NULL;
					gboolean _tmp20_ = FALSE;
					_tmp19_ = window;
					_tmp20_ = wnck_window_is_minimized (_tmp19_);
					_tmp17_ = _tmp20_;
				} else {
					_tmp17_ = FALSE;
				}
				_tmp21_ = _tmp17_;
				if (_tmp21_) {
					result = TRUE;
					_g_object_unref0 (window);
					_g_array_unref0 (xids);
					return result;
				}
				_g_object_unref0 (window);
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


gboolean plank_services_windows_window_control_has_window_on_workspace (BamfApplication* app, WnckWorkspace* workspace) {
	gboolean result = FALSE;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	gboolean is_virtual = FALSE;
	WnckWorkspace* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	g_return_val_if_fail (app != NULL, FALSE);
	g_return_val_if_fail (workspace != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = workspace;
	_tmp4_ = wnck_workspace_is_virtual (_tmp3_);
	is_virtual = _tmp4_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp8_ = FALSE;
				GArray* _tmp9_ = NULL;
				gboolean _tmp13_ = FALSE;
				WnckWindow* window = NULL;
				GArray* _tmp14_ = NULL;
				gint _tmp15_ = 0;
				guint32 _tmp16_ = 0U;
				WnckWindow* _tmp17_ = NULL;
				WnckWindow* _tmp18_ = NULL;
				WnckWindow* _tmp19_ = NULL;
				gboolean _tmp20_ = FALSE;
				_tmp6_ = _tmp5_;
				if (!_tmp6_) {
					gint _tmp7_ = 0;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp9_ = xids;
				if (_tmp9_ != NULL) {
					gint _tmp10_ = 0;
					GArray* _tmp11_ = NULL;
					guint _tmp12_ = 0U;
					_tmp10_ = i;
					_tmp11_ = xids;
					_tmp12_ = _tmp11_->len;
					_tmp8_ = ((guint) _tmp10_) < _tmp12_;
				} else {
					_tmp8_ = FALSE;
				}
				_tmp13_ = _tmp8_;
				if (!_tmp13_) {
					break;
				}
				_tmp14_ = xids;
				_tmp15_ = i;
				_tmp16_ = g_array_index (_tmp14_, guint32, (guint) _tmp15_);
				_tmp17_ = wnck_window_get ((gulong) _tmp16_);
				_tmp18_ = _g_object_ref0 (_tmp17_);
				window = _tmp18_;
				_tmp19_ = window;
				if (_tmp19_ == NULL) {
					_g_object_unref0 (window);
					continue;
				}
				_tmp20_ = is_virtual;
				if (!_tmp20_) {
					WnckWindow* _tmp21_ = NULL;
					WnckWorkspace* _tmp22_ = NULL;
					gboolean _tmp23_ = FALSE;
					_tmp21_ = window;
					_tmp22_ = workspace;
					_tmp23_ = wnck_window_is_on_workspace (_tmp21_, _tmp22_);
					if (_tmp23_) {
						result = TRUE;
						_g_object_unref0 (window);
						_g_array_unref0 (xids);
						return result;
					}
				} else {
					WnckWindow* _tmp24_ = NULL;
					WnckWorkspace* _tmp25_ = NULL;
					gboolean _tmp26_ = FALSE;
					_tmp24_ = window;
					_tmp25_ = workspace;
					_tmp26_ = wnck_window_is_in_viewport (_tmp24_, _tmp25_);
					if (_tmp26_) {
						result = TRUE;
						_g_object_unref0 (window);
						_g_array_unref0 (xids);
						return result;
					}
				}
				_g_object_unref0 (window);
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


GeeArrayList* plank_services_windows_window_control_get_windows (BamfApplication* app) {
	GeeArrayList* result = NULL;
	GeeArrayList* windows = NULL;
	GeeArrayList* _tmp0_ = NULL;
	GList* children = NULL;
	BamfApplication* _tmp1_ = NULL;
	GList* _tmp2_ = NULL;
	GList* _tmp3_ = NULL;
	GList* _tmp4_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	_tmp0_ = gee_array_list_new (bamf_window_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	windows = _tmp0_;
	_tmp1_ = app;
	_tmp2_ = bamf_application_get_windows (_tmp1_);
	children = _tmp2_;
	_tmp3_ = children;
	if (_tmp3_ == NULL) {
		result = windows;
		_g_list_free0 (children);
		return result;
	}
	_tmp4_ = children;
	{
		GList* view_collection = NULL;
		GList* view_it = NULL;
		view_collection = _tmp4_;
		for (view_it = view_collection; view_it != NULL; view_it = view_it->next) {
			BamfView* view = NULL;
			view = (BamfView*) view_it->data;
			{
				BamfView* _tmp5_ = NULL;
				_tmp5_ = view;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, bamf_window_get_type ())) {
					GeeArrayList* _tmp6_ = NULL;
					BamfView* _tmp7_ = NULL;
					_tmp6_ = windows;
					_tmp7_ = view;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, bamf_window_get_type ()) ? ((BamfWindow*) _tmp7_) : NULL);
				}
			}
		}
	}
	result = windows;
	_g_list_free0 (children);
	return result;
}


void plank_services_windows_window_control_update_icon_regions (BamfApplication* app, GdkRectangle* rect) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_if_fail (app != NULL);
	g_return_if_fail (rect != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_ = NULL;
				gboolean _tmp11_ = FALSE;
				WnckWindow* window = NULL;
				GArray* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				WnckWindow* _tmp16_ = NULL;
				WnckWindow* _tmp17_ = NULL;
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					gint _tmp5_ = 0;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp7_ = xids;
				if (_tmp7_ != NULL) {
					gint _tmp8_ = 0;
					GArray* _tmp9_ = NULL;
					guint _tmp10_ = 0U;
					_tmp8_ = i;
					_tmp9_ = xids;
					_tmp10_ = _tmp9_->len;
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
				} else {
					_tmp6_ = FALSE;
				}
				_tmp11_ = _tmp6_;
				if (!_tmp11_) {
					break;
				}
				_tmp12_ = xids;
				_tmp13_ = i;
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
				_tmp16_ = _g_object_ref0 (_tmp15_);
				window = _tmp16_;
				_tmp17_ = window;
				if (_tmp17_ != NULL) {
					WnckWindow* _tmp18_ = NULL;
					GdkRectangle _tmp19_ = {0};
					gint _tmp20_ = 0;
					GdkRectangle _tmp21_ = {0};
					gint _tmp22_ = 0;
					GdkRectangle _tmp23_ = {0};
					gint _tmp24_ = 0;
					GdkRectangle _tmp25_ = {0};
					gint _tmp26_ = 0;
					_tmp18_ = window;
					_tmp19_ = *rect;
					_tmp20_ = _tmp19_.x;
					_tmp21_ = *rect;
					_tmp22_ = _tmp21_.y;
					_tmp23_ = *rect;
					_tmp24_ = _tmp23_.width;
					_tmp25_ = *rect;
					_tmp26_ = _tmp25_.height;
					wnck_window_set_icon_geometry (_tmp18_, _tmp20_, _tmp22_, _tmp24_, _tmp26_);
				}
				_g_object_unref0 (window);
			}
		}
	}
	_g_array_unref0 (xids);
}


void plank_services_windows_window_control_close_all (BamfApplication* app) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_ = NULL;
				gboolean _tmp11_ = FALSE;
				WnckWindow* window = NULL;
				GArray* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				WnckWindow* _tmp16_ = NULL;
				gboolean _tmp17_ = FALSE;
				WnckWindow* _tmp18_ = NULL;
				gboolean _tmp21_ = FALSE;
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					gint _tmp5_ = 0;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp7_ = xids;
				if (_tmp7_ != NULL) {
					gint _tmp8_ = 0;
					GArray* _tmp9_ = NULL;
					guint _tmp10_ = 0U;
					_tmp8_ = i;
					_tmp9_ = xids;
					_tmp10_ = _tmp9_->len;
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
				} else {
					_tmp6_ = FALSE;
				}
				_tmp11_ = _tmp6_;
				if (!_tmp11_) {
					break;
				}
				_tmp12_ = xids;
				_tmp13_ = i;
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
				_tmp16_ = _g_object_ref0 (_tmp15_);
				window = _tmp16_;
				_tmp18_ = window;
				if (_tmp18_ != NULL) {
					WnckWindow* _tmp19_ = NULL;
					gboolean _tmp20_ = FALSE;
					_tmp19_ = window;
					_tmp20_ = wnck_window_is_skip_tasklist (_tmp19_);
					_tmp17_ = !_tmp20_;
				} else {
					_tmp17_ = FALSE;
				}
				_tmp21_ = _tmp17_;
				if (_tmp21_) {
					WnckWindow* _tmp22_ = NULL;
					guint32 _tmp23_ = 0U;
					_tmp22_ = window;
					_tmp23_ = gtk_get_current_event_time ();
					wnck_window_close (_tmp22_, _tmp23_);
				}
				_g_object_unref0 (window);
			}
		}
	}
	_g_array_unref0 (xids);
}


void plank_services_windows_window_control_focus_window (BamfWindow* window) {
	WnckWindow* w = NULL;
	BamfWindow* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	WnckWindow* _tmp2_ = NULL;
	WnckWindow* _tmp3_ = NULL;
	WnckWindow* _tmp4_ = NULL;
	WnckWindow* _tmp5_ = NULL;
	WnckWindow* _tmp6_ = NULL;
	g_return_if_fail (window != NULL);
	wnck_screen_get_default ();
	_tmp0_ = window;
	_tmp1_ = bamf_window_get_xid (_tmp0_);
	_tmp2_ = wnck_window_get ((gulong) _tmp1_);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	w = _tmp3_;
	_tmp4_ = w;
	g_warn_if_fail (_tmp4_ != NULL);
	_tmp5_ = w;
	if (_tmp5_ == NULL) {
		_g_object_unref0 (w);
		return;
	}
	_tmp6_ = w;
	plank_services_windows_window_control_center_and_focus_window (_tmp6_);
	_g_object_unref0 (w);
}


void plank_services_windows_window_control_focus_window_by_xid (guint32 xid) {
	WnckWindow* w = NULL;
	guint32 _tmp0_ = 0U;
	WnckWindow* _tmp1_ = NULL;
	WnckWindow* _tmp2_ = NULL;
	WnckWindow* _tmp3_ = NULL;
	WnckWindow* _tmp4_ = NULL;
	WnckWindow* _tmp5_ = NULL;
	wnck_screen_get_default ();
	_tmp0_ = xid;
	_tmp1_ = wnck_window_get ((gulong) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	w = _tmp2_;
	_tmp3_ = w;
	g_warn_if_fail (_tmp3_ != NULL);
	_tmp4_ = w;
	if (_tmp4_ == NULL) {
		_g_object_unref0 (w);
		return;
	}
	_tmp5_ = w;
	plank_services_windows_window_control_center_and_focus_window (_tmp5_);
	_g_object_unref0 (w);
}


void plank_services_windows_window_control_focus (BamfApplication* app) {
	g_return_if_fail (app != NULL);
	{
		GeeArrayList* _window_list = NULL;
		BamfApplication* _tmp0_ = NULL;
		GeeArrayList* _tmp1_ = NULL;
		gint _window_size = 0;
		GeeArrayList* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _window_index = 0;
		_tmp0_ = app;
		_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
		_window_list = _tmp1_;
		_tmp2_ = _window_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_window_size = _tmp4_;
		_window_index = -1;
		while (TRUE) {
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			WnckWindow* window = NULL;
			GeeArrayList* _tmp8_ = NULL;
			gint _tmp9_ = 0;
			gpointer _tmp10_ = NULL;
			WnckWindow* _tmp11_ = NULL;
			_tmp5_ = _window_index;
			_window_index = _tmp5_ + 1;
			_tmp6_ = _window_index;
			_tmp7_ = _window_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _window_list;
			_tmp9_ = _window_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			window = (WnckWindow*) _tmp10_;
			_tmp11_ = window;
			plank_services_windows_window_control_center_and_focus_window (_tmp11_);
			g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
			_g_object_unref0 (window);
		}
		_g_object_unref0 (_window_list);
	}
}


static gint plank_services_windows_window_control_find_active_xid_index (GArray* xids) {
	gint result = 0;
	gint i = 0;
	i = 0;
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			gboolean _tmp1_ = FALSE;
			gboolean _tmp3_ = FALSE;
			GArray* _tmp4_ = NULL;
			gboolean _tmp8_ = FALSE;
			WnckWindow* window = NULL;
			GArray* _tmp9_ = NULL;
			gint _tmp10_ = 0;
			guint32 _tmp11_ = 0U;
			WnckWindow* _tmp12_ = NULL;
			WnckWindow* _tmp13_ = NULL;
			gboolean _tmp14_ = FALSE;
			WnckWindow* _tmp15_ = NULL;
			gboolean _tmp18_ = FALSE;
			_tmp1_ = _tmp0_;
			if (!_tmp1_) {
				gint _tmp2_ = 0;
				_tmp2_ = i;
				i = _tmp2_ + 1;
			}
			_tmp0_ = FALSE;
			_tmp4_ = xids;
			if (_tmp4_ != NULL) {
				gint _tmp5_ = 0;
				GArray* _tmp6_ = NULL;
				guint _tmp7_ = 0U;
				_tmp5_ = i;
				_tmp6_ = xids;
				_tmp7_ = _tmp6_->len;
				_tmp3_ = ((guint) _tmp5_) < _tmp7_;
			} else {
				_tmp3_ = FALSE;
			}
			_tmp8_ = _tmp3_;
			if (!_tmp8_) {
				break;
			}
			_tmp9_ = xids;
			_tmp10_ = i;
			_tmp11_ = g_array_index (_tmp9_, guint32, (guint) _tmp10_);
			_tmp12_ = wnck_window_get ((gulong) _tmp11_);
			_tmp13_ = _g_object_ref0 (_tmp12_);
			window = _tmp13_;
			_tmp15_ = window;
			if (_tmp15_ != NULL) {
				WnckWindow* _tmp16_ = NULL;
				gboolean _tmp17_ = FALSE;
				_tmp16_ = window;
				_tmp17_ = wnck_window_is_active (_tmp16_);
				_tmp14_ = _tmp17_;
			} else {
				_tmp14_ = FALSE;
			}
			_tmp18_ = _tmp14_;
			if (_tmp18_) {
				_g_object_unref0 (window);
				break;
			}
			_g_object_unref0 (window);
		}
	}
	result = i;
	return result;
}


void plank_services_windows_window_control_focus_previous (BamfApplication* app) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GArray* _tmp3_ = NULL;
	gint i = 0;
	GArray* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	GArray* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	GArray* _tmp15_ = NULL;
	gint _tmp16_ = 0;
	guint32 _tmp17_ = 0U;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = xids;
	if (_tmp3_ == NULL) {
		_g_array_unref0 (xids);
		return;
	}
	_tmp4_ = xids;
	_tmp5_ = plank_services_windows_window_control_find_active_xid_index (_tmp4_);
	i = _tmp5_;
	_tmp7_ = i;
	_tmp8_ = xids;
	_tmp9_ = _tmp8_->len;
	if (((guint) _tmp7_) < _tmp9_) {
		gint _tmp10_ = 0;
		_tmp10_ = i;
		_tmp6_ = _tmp10_ - 1;
	} else {
		_tmp6_ = 0;
	}
	_tmp11_ = _tmp6_;
	i = _tmp11_;
	_tmp12_ = i;
	if (_tmp12_ < 0) {
		GArray* _tmp13_ = NULL;
		guint _tmp14_ = 0U;
		_tmp13_ = xids;
		_tmp14_ = _tmp13_->len;
		i = ((gint) _tmp14_) - 1;
	}
	_tmp15_ = xids;
	_tmp16_ = i;
	_tmp17_ = g_array_index (_tmp15_, guint32, (guint) _tmp16_);
	plank_services_windows_window_control_focus_window_by_xid (_tmp17_);
	_g_array_unref0 (xids);
}


void plank_services_windows_window_control_focus_next (BamfApplication* app) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GArray* _tmp3_ = NULL;
	gint i = 0;
	GArray* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	GArray* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	GArray* _tmp13_ = NULL;
	guint _tmp14_ = 0U;
	GArray* _tmp15_ = NULL;
	gint _tmp16_ = 0;
	guint32 _tmp17_ = 0U;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = xids;
	if (_tmp3_ == NULL) {
		_g_array_unref0 (xids);
		return;
	}
	_tmp4_ = xids;
	_tmp5_ = plank_services_windows_window_control_find_active_xid_index (_tmp4_);
	i = _tmp5_;
	_tmp7_ = i;
	_tmp8_ = xids;
	_tmp9_ = _tmp8_->len;
	if (((guint) _tmp7_) < _tmp9_) {
		gint _tmp10_ = 0;
		_tmp10_ = i;
		_tmp6_ = _tmp10_ + 1;
	} else {
		_tmp6_ = 0;
	}
	_tmp11_ = _tmp6_;
	i = _tmp11_;
	_tmp12_ = i;
	_tmp13_ = xids;
	_tmp14_ = _tmp13_->len;
	if (((guint) _tmp12_) == _tmp14_) {
		i = 0;
	}
	_tmp15_ = xids;
	_tmp16_ = i;
	_tmp17_ = g_array_index (_tmp15_, guint32, (guint) _tmp16_);
	plank_services_windows_window_control_focus_window_by_xid (_tmp17_);
	_g_array_unref0 (xids);
}


void plank_services_windows_window_control_minimize (BamfApplication* app) {
	g_return_if_fail (app != NULL);
	{
		GeeArrayList* _window_list = NULL;
		BamfApplication* _tmp0_ = NULL;
		GeeArrayList* _tmp1_ = NULL;
		gint _window_size = 0;
		GeeArrayList* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _window_index = 0;
		_tmp0_ = app;
		_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
		_window_list = _tmp1_;
		_tmp2_ = _window_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_window_size = _tmp4_;
		_window_index = -1;
		while (TRUE) {
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			WnckWindow* window = NULL;
			GeeArrayList* _tmp8_ = NULL;
			gint _tmp9_ = 0;
			gpointer _tmp10_ = NULL;
			gboolean _tmp11_ = FALSE;
			WnckWindow* _tmp12_ = NULL;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp19_ = FALSE;
			_tmp5_ = _window_index;
			_window_index = _tmp5_ + 1;
			_tmp6_ = _window_index;
			_tmp7_ = _window_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _window_list;
			_tmp9_ = _window_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			window = (WnckWindow*) _tmp10_;
			_tmp12_ = window;
			_tmp13_ = wnck_window_is_minimized (_tmp12_);
			if (!_tmp13_) {
				WnckWindow* _tmp14_ = NULL;
				WnckWindow* _tmp15_ = NULL;
				WnckScreen* _tmp16_ = NULL;
				WnckWorkspace* _tmp17_ = NULL;
				gboolean _tmp18_ = FALSE;
				_tmp14_ = window;
				_tmp15_ = window;
				_tmp16_ = wnck_window_get_screen (_tmp15_);
				_tmp17_ = wnck_screen_get_active_workspace (_tmp16_);
				_tmp18_ = wnck_window_is_in_viewport (_tmp14_, _tmp17_);
				_tmp11_ = _tmp18_;
			} else {
				_tmp11_ = FALSE;
			}
			_tmp19_ = _tmp11_;
			if (_tmp19_) {
				WnckWindow* _tmp20_ = NULL;
				_tmp20_ = window;
				wnck_window_minimize (_tmp20_);
				g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
			}
			_g_object_unref0 (window);
		}
		_g_object_unref0 (_window_list);
	}
}


void plank_services_windows_window_control_restore (BamfApplication* app) {
	GeeArrayList* stack = NULL;
	BamfApplication* _tmp0_ = NULL;
	GeeArrayList* _tmp1_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
	stack = _tmp1_;
	{
		gint i = 0;
		GeeArrayList* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		_tmp2_ = stack;
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		i = ((gint) _tmp4_) - 1;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gint _tmp8_ = 0;
				WnckWindow* window = NULL;
				GeeArrayList* _tmp9_ = NULL;
				gint _tmp10_ = 0;
				gpointer _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				WnckWindow* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				gboolean _tmp20_ = FALSE;
				_tmp6_ = _tmp5_;
				if (!_tmp6_) {
					gint _tmp7_ = 0;
					_tmp7_ = i;
					i = _tmp7_ - 1;
				}
				_tmp5_ = FALSE;
				_tmp8_ = i;
				if (!(_tmp8_ >= 0)) {
					break;
				}
				_tmp9_ = stack;
				_tmp10_ = i;
				_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
				window = (WnckWindow*) _tmp11_;
				_tmp13_ = window;
				_tmp14_ = wnck_window_is_minimized (_tmp13_);
				if (_tmp14_) {
					WnckWindow* _tmp15_ = NULL;
					WnckWindow* _tmp16_ = NULL;
					WnckScreen* _tmp17_ = NULL;
					WnckWorkspace* _tmp18_ = NULL;
					gboolean _tmp19_ = FALSE;
					_tmp15_ = window;
					_tmp16_ = window;
					_tmp17_ = wnck_window_get_screen (_tmp16_);
					_tmp18_ = wnck_screen_get_active_workspace (_tmp17_);
					_tmp19_ = wnck_window_is_in_viewport (_tmp15_, _tmp18_);
					_tmp12_ = _tmp19_;
				} else {
					_tmp12_ = FALSE;
				}
				_tmp20_ = _tmp12_;
				if (_tmp20_) {
					WnckWindow* _tmp21_ = NULL;
					guint32 _tmp22_ = 0U;
					_tmp21_ = window;
					_tmp22_ = gtk_get_current_event_time ();
					wnck_window_unminimize (_tmp21_, _tmp22_);
					g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
				}
				_g_object_unref0 (window);
			}
		}
	}
	_g_object_unref0 (stack);
}


void plank_services_windows_window_control_maximize (BamfApplication* app) {
	g_return_if_fail (app != NULL);
	{
		GeeArrayList* _window_list = NULL;
		BamfApplication* _tmp0_ = NULL;
		GeeArrayList* _tmp1_ = NULL;
		gint _window_size = 0;
		GeeArrayList* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _window_index = 0;
		_tmp0_ = app;
		_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
		_window_list = _tmp1_;
		_tmp2_ = _window_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_window_size = _tmp4_;
		_window_index = -1;
		while (TRUE) {
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			WnckWindow* window = NULL;
			GeeArrayList* _tmp8_ = NULL;
			gint _tmp9_ = 0;
			gpointer _tmp10_ = NULL;
			WnckWindow* _tmp11_ = NULL;
			gboolean _tmp12_ = FALSE;
			_tmp5_ = _window_index;
			_window_index = _tmp5_ + 1;
			_tmp6_ = _window_index;
			_tmp7_ = _window_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _window_list;
			_tmp9_ = _window_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			window = (WnckWindow*) _tmp10_;
			_tmp11_ = window;
			_tmp12_ = wnck_window_is_maximized (_tmp11_);
			if (!_tmp12_) {
				WnckWindow* _tmp13_ = NULL;
				_tmp13_ = window;
				wnck_window_maximize (_tmp13_);
			}
			_g_object_unref0 (window);
		}
		_g_object_unref0 (_window_list);
	}
}


void plank_services_windows_window_control_unmaximize (BamfApplication* app) {
	g_return_if_fail (app != NULL);
	{
		GeeArrayList* _window_list = NULL;
		BamfApplication* _tmp0_ = NULL;
		GeeArrayList* _tmp1_ = NULL;
		gint _window_size = 0;
		GeeArrayList* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _window_index = 0;
		_tmp0_ = app;
		_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
		_window_list = _tmp1_;
		_tmp2_ = _window_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_window_size = _tmp4_;
		_window_index = -1;
		while (TRUE) {
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			WnckWindow* window = NULL;
			GeeArrayList* _tmp8_ = NULL;
			gint _tmp9_ = 0;
			gpointer _tmp10_ = NULL;
			WnckWindow* _tmp11_ = NULL;
			gboolean _tmp12_ = FALSE;
			_tmp5_ = _window_index;
			_window_index = _tmp5_ + 1;
			_tmp6_ = _window_index;
			_tmp7_ = _window_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _window_list;
			_tmp9_ = _window_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			window = (WnckWindow*) _tmp10_;
			_tmp11_ = window;
			_tmp12_ = wnck_window_is_maximized (_tmp11_);
			if (_tmp12_) {
				WnckWindow* _tmp13_ = NULL;
				_tmp13_ = window;
				wnck_window_unmaximize (_tmp13_);
			}
			_g_object_unref0 (window);
		}
		_g_object_unref0 (_window_list);
	}
}


GeeArrayList* plank_services_windows_window_control_get_ordered_window_stack (BamfApplication* app) {
	GeeArrayList* result = NULL;
	GeeArrayList* windows = NULL;
	GeeArrayList* _tmp0_ = NULL;
	GArray* xids = NULL;
	BamfApplication* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GArray* _tmp3_ = NULL;
	GArray* _tmp4_ = NULL;
	GList* stack = NULL;
	WnckScreen* _tmp5_ = NULL;
	GList* _tmp6_ = NULL;
	GList* _tmp7_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	_tmp0_ = gee_array_list_new (wnck_window_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	windows = _tmp0_;
	wnck_screen_get_default ();
	_tmp1_ = app;
	_tmp2_ = bamf_application_get_xids (_tmp1_);
	xids = _tmp2_;
	_tmp3_ = xids;
	g_warn_if_fail (_tmp3_ != NULL);
	_tmp4_ = xids;
	if (_tmp4_ == NULL) {
		result = windows;
		_g_array_unref0 (xids);
		return result;
	}
	_tmp5_ = wnck_screen_get_default ();
	_tmp6_ = wnck_screen_get_windows_stacked (_tmp5_);
	stack = _tmp6_;
	_tmp7_ = stack;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp7_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* _tmp8_ = NULL;
			WnckWindow* window = NULL;
			_tmp8_ = _g_object_ref0 ((WnckWindow*) window_it->data);
			window = _tmp8_;
			{
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp9_ = FALSE;
						_tmp9_ = TRUE;
						while (TRUE) {
							gboolean _tmp10_ = FALSE;
							gint _tmp12_ = 0;
							GArray* _tmp13_ = NULL;
							guint _tmp14_ = 0U;
							GArray* _tmp15_ = NULL;
							gint _tmp16_ = 0;
							guint32 _tmp17_ = 0U;
							WnckWindow* _tmp18_ = NULL;
							gulong _tmp19_ = 0UL;
							_tmp10_ = _tmp9_;
							if (!_tmp10_) {
								gint _tmp11_ = 0;
								_tmp11_ = j;
								j = _tmp11_ + 1;
							}
							_tmp9_ = FALSE;
							_tmp12_ = j;
							_tmp13_ = xids;
							_tmp14_ = _tmp13_->len;
							if (!(((guint) _tmp12_) < _tmp14_)) {
								break;
							}
							_tmp15_ = xids;
							_tmp16_ = j;
							_tmp17_ = g_array_index (_tmp15_, guint32, (guint) _tmp16_);
							_tmp18_ = window;
							_tmp19_ = wnck_window_get_xid (_tmp18_);
							if (((gulong) _tmp17_) == _tmp19_) {
								GeeArrayList* _tmp20_ = NULL;
								WnckWindow* _tmp21_ = NULL;
								_tmp20_ = windows;
								_tmp21_ = window;
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
							}
						}
					}
				}
				_g_object_unref0 (window);
			}
		}
	}
	result = windows;
	_g_array_unref0 (xids);
	return result;
}


void plank_services_windows_window_control_smart_focus (BamfApplication* app) {
	GeeArrayList* windows = NULL;
	BamfApplication* _tmp0_ = NULL;
	GeeArrayList* _tmp1_ = NULL;
	gboolean not_in_viewport = FALSE;
	gboolean urgent = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp27_ = FALSE;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
	windows = _tmp1_;
	not_in_viewport = TRUE;
	urgent = FALSE;
	{
		GeeArrayList* _window_list = NULL;
		GeeArrayList* _tmp2_ = NULL;
		GeeArrayList* _tmp3_ = NULL;
		gint _window_size = 0;
		GeeArrayList* _tmp4_ = NULL;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		gint _window_index = 0;
		_tmp2_ = windows;
		_tmp3_ = _g_object_ref0 (_tmp2_);
		_window_list = _tmp3_;
		_tmp4_ = _window_list;
		_tmp5_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_window_size = _tmp6_;
		_window_index = -1;
		while (TRUE) {
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
			gint _tmp9_ = 0;
			WnckWindow* window = NULL;
			GeeArrayList* _tmp10_ = NULL;
			gint _tmp11_ = 0;
			gpointer _tmp12_ = NULL;
			gboolean _tmp13_ = FALSE;
			WnckWindow* _tmp14_ = NULL;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp21_ = FALSE;
			WnckWindow* _tmp22_ = NULL;
			gboolean _tmp23_ = FALSE;
			_tmp7_ = _window_index;
			_window_index = _tmp7_ + 1;
			_tmp8_ = _window_index;
			_tmp9_ = _window_size;
			if (!(_tmp8_ < _tmp9_)) {
				break;
			}
			_tmp10_ = _window_list;
			_tmp11_ = _window_index;
			_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _tmp11_);
			window = (WnckWindow*) _tmp12_;
			_tmp14_ = window;
			_tmp15_ = wnck_window_is_skip_tasklist (_tmp14_);
			if (!_tmp15_) {
				WnckWindow* _tmp16_ = NULL;
				WnckWindow* _tmp17_ = NULL;
				WnckScreen* _tmp18_ = NULL;
				WnckWorkspace* _tmp19_ = NULL;
				gboolean _tmp20_ = FALSE;
				_tmp16_ = window;
				_tmp17_ = window;
				_tmp18_ = wnck_window_get_screen (_tmp17_);
				_tmp19_ = wnck_screen_get_active_workspace (_tmp18_);
				_tmp20_ = wnck_window_is_in_viewport (_tmp16_, _tmp19_);
				_tmp13_ = _tmp20_;
			} else {
				_tmp13_ = FALSE;
			}
			_tmp21_ = _tmp13_;
			if (_tmp21_) {
				not_in_viewport = FALSE;
			}
			_tmp22_ = window;
			_tmp23_ = wnck_window_needs_attention (_tmp22_);
			if (_tmp23_) {
				urgent = TRUE;
			}
			_g_object_unref0 (window);
		}
		_g_object_unref0 (_window_list);
	}
	_tmp25_ = not_in_viewport;
	if (_tmp25_) {
		_tmp24_ = TRUE;
	} else {
		gboolean _tmp26_ = FALSE;
		_tmp26_ = urgent;
		_tmp24_ = _tmp26_;
	}
	_tmp27_ = _tmp24_;
	if (_tmp27_) {
		{
			GeeArrayList* _window_list = NULL;
			GeeArrayList* _tmp28_ = NULL;
			GeeArrayList* _tmp29_ = NULL;
			gint _window_size = 0;
			GeeArrayList* _tmp30_ = NULL;
			gint _tmp31_ = 0;
			gint _tmp32_ = 0;
			gint _window_index = 0;
			_tmp28_ = windows;
			_tmp29_ = _g_object_ref0 (_tmp28_);
			_window_list = _tmp29_;
			_tmp30_ = _window_list;
			_tmp31_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp30_);
			_tmp32_ = _tmp31_;
			_window_size = _tmp32_;
			_window_index = -1;
			while (TRUE) {
				gint _tmp33_ = 0;
				gint _tmp34_ = 0;
				gint _tmp35_ = 0;
				WnckWindow* window = NULL;
				GeeArrayList* _tmp36_ = NULL;
				gint _tmp37_ = 0;
				gpointer _tmp38_ = NULL;
				gboolean _tmp39_ = FALSE;
				gboolean _tmp40_ = FALSE;
				gboolean _tmp43_ = FALSE;
				WnckWindow* _tmp44_ = NULL;
				gboolean _tmp45_ = FALSE;
				_tmp33_ = _window_index;
				_window_index = _tmp33_ + 1;
				_tmp34_ = _window_index;
				_tmp35_ = _window_size;
				if (!(_tmp34_ < _tmp35_)) {
					break;
				}
				_tmp36_ = _window_list;
				_tmp37_ = _window_index;
				_tmp38_ = gee_abstract_list_get ((GeeAbstractList*) _tmp36_, _tmp37_);
				window = (WnckWindow*) _tmp38_;
				_tmp40_ = urgent;
				if (_tmp40_) {
					WnckWindow* _tmp41_ = NULL;
					gboolean _tmp42_ = FALSE;
					_tmp41_ = window;
					_tmp42_ = wnck_window_needs_attention (_tmp41_);
					_tmp39_ = !_tmp42_;
				} else {
					_tmp39_ = FALSE;
				}
				_tmp43_ = _tmp39_;
				if (_tmp43_) {
					_g_object_unref0 (window);
					continue;
				}
				_tmp44_ = window;
				_tmp45_ = wnck_window_is_skip_tasklist (_tmp44_);
				if (!_tmp45_) {
					WnckWindow* _tmp46_ = NULL;
					GeeArrayList* _tmp47_ = NULL;
					_tmp46_ = window;
					_tmp47_ = windows;
					plank_services_windows_window_control_intelligent_focus_off_viewport_window (_tmp46_, _tmp47_);
					_g_object_unref0 (window);
					_g_object_unref0 (_window_list);
					_g_object_unref0 (windows);
					return;
				}
				_g_object_unref0 (window);
			}
			_g_object_unref0 (_window_list);
		}
	}
	{
		GeeArrayList* _window_list = NULL;
		GeeArrayList* _tmp48_ = NULL;
		GeeArrayList* _tmp49_ = NULL;
		gint _window_size = 0;
		GeeArrayList* _tmp50_ = NULL;
		gint _tmp51_ = 0;
		gint _tmp52_ = 0;
		gint _window_index = 0;
		_tmp48_ = windows;
		_tmp49_ = _g_object_ref0 (_tmp48_);
		_window_list = _tmp49_;
		_tmp50_ = _window_list;
		_tmp51_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp50_);
		_tmp52_ = _tmp51_;
		_window_size = _tmp52_;
		_window_index = -1;
		while (TRUE) {
			gint _tmp53_ = 0;
			gint _tmp54_ = 0;
			gint _tmp55_ = 0;
			WnckWindow* window = NULL;
			GeeArrayList* _tmp56_ = NULL;
			gint _tmp57_ = 0;
			gpointer _tmp58_ = NULL;
			gboolean _tmp59_ = FALSE;
			WnckWindow* _tmp60_ = NULL;
			gboolean _tmp61_ = FALSE;
			gboolean _tmp67_ = FALSE;
			_tmp53_ = _window_index;
			_window_index = _tmp53_ + 1;
			_tmp54_ = _window_index;
			_tmp55_ = _window_size;
			if (!(_tmp54_ < _tmp55_)) {
				break;
			}
			_tmp56_ = _window_list;
			_tmp57_ = _window_index;
			_tmp58_ = gee_abstract_list_get ((GeeAbstractList*) _tmp56_, _tmp57_);
			window = (WnckWindow*) _tmp58_;
			_tmp60_ = window;
			_tmp61_ = wnck_window_is_minimized (_tmp60_);
			if (_tmp61_) {
				WnckWindow* _tmp62_ = NULL;
				WnckWindow* _tmp63_ = NULL;
				WnckScreen* _tmp64_ = NULL;
				WnckWorkspace* _tmp65_ = NULL;
				gboolean _tmp66_ = FALSE;
				_tmp62_ = window;
				_tmp63_ = window;
				_tmp64_ = wnck_window_get_screen (_tmp63_);
				_tmp65_ = wnck_screen_get_active_workspace (_tmp64_);
				_tmp66_ = wnck_window_is_in_viewport (_tmp62_, _tmp65_);
				_tmp59_ = _tmp66_;
			} else {
				_tmp59_ = FALSE;
			}
			_tmp67_ = _tmp59_;
			if (_tmp67_) {
				{
					GeeArrayList* _w_list = NULL;
					GeeArrayList* _tmp68_ = NULL;
					GeeArrayList* _tmp69_ = NULL;
					gint _w_size = 0;
					GeeArrayList* _tmp70_ = NULL;
					gint _tmp71_ = 0;
					gint _tmp72_ = 0;
					gint _w_index = 0;
					_tmp68_ = windows;
					_tmp69_ = _g_object_ref0 (_tmp68_);
					_w_list = _tmp69_;
					_tmp70_ = _w_list;
					_tmp71_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp70_);
					_tmp72_ = _tmp71_;
					_w_size = _tmp72_;
					_w_index = -1;
					while (TRUE) {
						gint _tmp73_ = 0;
						gint _tmp74_ = 0;
						gint _tmp75_ = 0;
						WnckWindow* w = NULL;
						GeeArrayList* _tmp76_ = NULL;
						gint _tmp77_ = 0;
						gpointer _tmp78_ = NULL;
						gboolean _tmp79_ = FALSE;
						WnckWindow* _tmp80_ = NULL;
						gboolean _tmp81_ = FALSE;
						gboolean _tmp87_ = FALSE;
						_tmp73_ = _w_index;
						_w_index = _tmp73_ + 1;
						_tmp74_ = _w_index;
						_tmp75_ = _w_size;
						if (!(_tmp74_ < _tmp75_)) {
							break;
						}
						_tmp76_ = _w_list;
						_tmp77_ = _w_index;
						_tmp78_ = gee_abstract_list_get ((GeeAbstractList*) _tmp76_, _tmp77_);
						w = (WnckWindow*) _tmp78_;
						_tmp80_ = w;
						_tmp81_ = wnck_window_is_minimized (_tmp80_);
						if (_tmp81_) {
							WnckWindow* _tmp82_ = NULL;
							WnckWindow* _tmp83_ = NULL;
							WnckScreen* _tmp84_ = NULL;
							WnckWorkspace* _tmp85_ = NULL;
							gboolean _tmp86_ = FALSE;
							_tmp82_ = w;
							_tmp83_ = w;
							_tmp84_ = wnck_window_get_screen (_tmp83_);
							_tmp85_ = wnck_screen_get_active_workspace (_tmp84_);
							_tmp86_ = wnck_window_is_in_viewport (_tmp82_, _tmp85_);
							_tmp79_ = _tmp86_;
						} else {
							_tmp79_ = FALSE;
						}
						_tmp87_ = _tmp79_;
						if (_tmp87_) {
							WnckWindow* _tmp88_ = NULL;
							guint32 _tmp89_ = 0U;
							_tmp88_ = w;
							_tmp89_ = gtk_get_current_event_time ();
							wnck_window_unminimize (_tmp88_, _tmp89_);
							g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
						}
						_g_object_unref0 (w);
					}
					_g_object_unref0 (_w_list);
				}
				_g_object_unref0 (window);
				_g_object_unref0 (_window_list);
				_g_object_unref0 (windows);
				return;
			}
			_g_object_unref0 (window);
		}
		_g_object_unref0 (_window_list);
	}
	{
		GeeArrayList* _window_list = NULL;
		GeeArrayList* _tmp90_ = NULL;
		GeeArrayList* _tmp91_ = NULL;
		gint _window_size = 0;
		GeeArrayList* _tmp92_ = NULL;
		gint _tmp93_ = 0;
		gint _tmp94_ = 0;
		gint _window_index = 0;
		_tmp90_ = windows;
		_tmp91_ = _g_object_ref0 (_tmp90_);
		_window_list = _tmp91_;
		_tmp92_ = _window_list;
		_tmp93_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp92_);
		_tmp94_ = _tmp93_;
		_window_size = _tmp94_;
		_window_index = -1;
		while (TRUE) {
			gint _tmp95_ = 0;
			gint _tmp96_ = 0;
			gint _tmp97_ = 0;
			WnckWindow* window = NULL;
			GeeArrayList* _tmp98_ = NULL;
			gint _tmp99_ = 0;
			gpointer _tmp100_ = NULL;
			gboolean _tmp101_ = FALSE;
			gboolean _tmp102_ = FALSE;
			WnckWindow* _tmp103_ = NULL;
			gboolean _tmp104_ = FALSE;
			gboolean _tmp110_ = FALSE;
			gboolean _tmp114_ = FALSE;
			_tmp95_ = _window_index;
			_window_index = _tmp95_ + 1;
			_tmp96_ = _window_index;
			_tmp97_ = _window_size;
			if (!(_tmp96_ < _tmp97_)) {
				break;
			}
			_tmp98_ = _window_list;
			_tmp99_ = _window_index;
			_tmp100_ = gee_abstract_list_get ((GeeAbstractList*) _tmp98_, _tmp99_);
			window = (WnckWindow*) _tmp100_;
			_tmp103_ = window;
			_tmp104_ = wnck_window_is_active (_tmp103_);
			if (_tmp104_) {
				WnckWindow* _tmp105_ = NULL;
				WnckWindow* _tmp106_ = NULL;
				WnckScreen* _tmp107_ = NULL;
				WnckWorkspace* _tmp108_ = NULL;
				gboolean _tmp109_ = FALSE;
				_tmp105_ = window;
				_tmp106_ = window;
				_tmp107_ = wnck_window_get_screen (_tmp106_);
				_tmp108_ = wnck_screen_get_active_workspace (_tmp107_);
				_tmp109_ = wnck_window_is_in_viewport (_tmp105_, _tmp108_);
				_tmp102_ = _tmp109_;
			} else {
				_tmp102_ = FALSE;
			}
			_tmp110_ = _tmp102_;
			if (_tmp110_) {
				_tmp101_ = TRUE;
			} else {
				WnckWindow* _tmp111_ = NULL;
				WnckScreen* _tmp112_ = NULL;
				WnckWindow* _tmp113_ = NULL;
				_tmp111_ = window;
				_tmp112_ = wnck_screen_get_default ();
				_tmp113_ = wnck_screen_get_active_window (_tmp112_);
				_tmp101_ = _tmp111_ == _tmp113_;
			}
			_tmp114_ = _tmp101_;
			if (_tmp114_) {
				{
					GeeArrayList* _w_list = NULL;
					GeeArrayList* _tmp115_ = NULL;
					GeeArrayList* _tmp116_ = NULL;
					gint _w_size = 0;
					GeeArrayList* _tmp117_ = NULL;
					gint _tmp118_ = 0;
					gint _tmp119_ = 0;
					gint _w_index = 0;
					_tmp115_ = windows;
					_tmp116_ = _g_object_ref0 (_tmp115_);
					_w_list = _tmp116_;
					_tmp117_ = _w_list;
					_tmp118_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp117_);
					_tmp119_ = _tmp118_;
					_w_size = _tmp119_;
					_w_index = -1;
					while (TRUE) {
						gint _tmp120_ = 0;
						gint _tmp121_ = 0;
						gint _tmp122_ = 0;
						WnckWindow* w = NULL;
						GeeArrayList* _tmp123_ = NULL;
						gint _tmp124_ = 0;
						gpointer _tmp125_ = NULL;
						gboolean _tmp126_ = FALSE;
						WnckWindow* _tmp127_ = NULL;
						gboolean _tmp128_ = FALSE;
						gboolean _tmp134_ = FALSE;
						_tmp120_ = _w_index;
						_w_index = _tmp120_ + 1;
						_tmp121_ = _w_index;
						_tmp122_ = _w_size;
						if (!(_tmp121_ < _tmp122_)) {
							break;
						}
						_tmp123_ = _w_list;
						_tmp124_ = _w_index;
						_tmp125_ = gee_abstract_list_get ((GeeAbstractList*) _tmp123_, _tmp124_);
						w = (WnckWindow*) _tmp125_;
						_tmp127_ = w;
						_tmp128_ = wnck_window_is_minimized (_tmp127_);
						if (!_tmp128_) {
							WnckWindow* _tmp129_ = NULL;
							WnckWindow* _tmp130_ = NULL;
							WnckScreen* _tmp131_ = NULL;
							WnckWorkspace* _tmp132_ = NULL;
							gboolean _tmp133_ = FALSE;
							_tmp129_ = w;
							_tmp130_ = w;
							_tmp131_ = wnck_window_get_screen (_tmp130_);
							_tmp132_ = wnck_screen_get_active_workspace (_tmp131_);
							_tmp133_ = wnck_window_is_in_viewport (_tmp129_, _tmp132_);
							_tmp126_ = _tmp133_;
						} else {
							_tmp126_ = FALSE;
						}
						_tmp134_ = _tmp126_;
						if (_tmp134_) {
							WnckWindow* _tmp135_ = NULL;
							_tmp135_ = w;
							wnck_window_minimize (_tmp135_);
							g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
						}
						_g_object_unref0 (w);
					}
					_g_object_unref0 (_w_list);
				}
				_g_object_unref0 (window);
				_g_object_unref0 (_window_list);
				_g_object_unref0 (windows);
				return;
			}
			_g_object_unref0 (window);
		}
		_g_object_unref0 (_window_list);
	}
	{
		GeeArrayList* _window_list = NULL;
		GeeArrayList* _tmp136_ = NULL;
		GeeArrayList* _tmp137_ = NULL;
		gint _window_size = 0;
		GeeArrayList* _tmp138_ = NULL;
		gint _tmp139_ = 0;
		gint _tmp140_ = 0;
		gint _window_index = 0;
		_tmp136_ = windows;
		_tmp137_ = _g_object_ref0 (_tmp136_);
		_window_list = _tmp137_;
		_tmp138_ = _window_list;
		_tmp139_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp138_);
		_tmp140_ = _tmp139_;
		_window_size = _tmp140_;
		_window_index = -1;
		while (TRUE) {
			gint _tmp141_ = 0;
			gint _tmp142_ = 0;
			gint _tmp143_ = 0;
			WnckWindow* window = NULL;
			GeeArrayList* _tmp144_ = NULL;
			gint _tmp145_ = 0;
			gpointer _tmp146_ = NULL;
			WnckWindow* _tmp147_ = NULL;
			_tmp141_ = _window_index;
			_window_index = _tmp141_ + 1;
			_tmp142_ = _window_index;
			_tmp143_ = _window_size;
			if (!(_tmp142_ < _tmp143_)) {
				break;
			}
			_tmp144_ = _window_list;
			_tmp145_ = _window_index;
			_tmp146_ = gee_abstract_list_get ((GeeAbstractList*) _tmp144_, _tmp145_);
			window = (WnckWindow*) _tmp146_;
			_tmp147_ = window;
			plank_services_windows_window_control_center_and_focus_window (_tmp147_);
			g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
			_g_object_unref0 (window);
		}
		_g_object_unref0 (_window_list);
	}
	_g_object_unref0 (windows);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		_g_object_unref0 (_data1_->targetWindow);
		g_slice_free (Block1Data, _data1_);
	}
}


static gboolean __lambda2_ (Block1Data* _data1_) {
	gboolean result = FALSE;
	WnckWindow* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	_tmp0_ = _data1_->targetWindow;
	_tmp1_ = _data1_->time;
	wnck_window_activate (_tmp0_, _tmp1_);
	result = FALSE;
	return result;
}


static gboolean ___lambda2__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda2_ (self);
	return result;
}


static void plank_services_windows_window_control_intelligent_focus_off_viewport_window (WnckWindow* targetWindow, GeeArrayList* additional_windows) {
	Block1Data* _data1_;
	WnckWindow* _tmp0_ = NULL;
	WnckWindow* _tmp1_ = NULL;
	GeeBidirListIterator* iterator = NULL;
	GeeArrayList* _tmp2_ = NULL;
	GeeBidirListIterator* _tmp3_ = NULL;
	GeeBidirListIterator* _tmp4_ = NULL;
	WnckWindow* _tmp17_ = NULL;
	GeeArrayList* _tmp18_ = NULL;
	gint _tmp19_ = 0;
	gint _tmp20_ = 0;
	guint32 _tmp21_ = 0U;
	g_return_if_fail (targetWindow != NULL);
	g_return_if_fail (additional_windows != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_tmp0_ = targetWindow;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data1_->targetWindow);
	_data1_->targetWindow = _tmp1_;
	_tmp2_ = additional_windows;
	_tmp3_ = gee_abstract_bidir_list_bidir_list_iterator ((GeeAbstractBidirList*) _tmp2_);
	iterator = _tmp3_;
	_tmp4_ = iterator;
	gee_bidir_iterator_last ((GeeBidirIterator*) _tmp4_);
	while (TRUE) {
		GeeBidirListIterator* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
		WnckWindow* window = NULL;
		GeeBidirListIterator* _tmp7_ = NULL;
		gpointer _tmp8_ = NULL;
		gboolean _tmp9_ = FALSE;
		WnckWindow* _tmp10_ = NULL;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp15_ = FALSE;
		_tmp5_ = iterator;
		_tmp6_ = gee_bidir_iterator_previous ((GeeBidirIterator*) _tmp5_);
		if (!_tmp6_) {
			break;
		}
		_tmp7_ = iterator;
		_tmp8_ = gee_iterator_get ((GeeIterator*) _tmp7_);
		window = (WnckWindow*) _tmp8_;
		_tmp10_ = window;
		_tmp11_ = wnck_window_is_minimized (_tmp10_);
		if (!_tmp11_) {
			WnckWindow* _tmp12_ = NULL;
			WnckWindow* _tmp13_ = NULL;
			gboolean _tmp14_ = FALSE;
			_tmp12_ = _data1_->targetWindow;
			_tmp13_ = window;
			_tmp14_ = plank_services_windows_window_control_windows_share_viewport (_tmp12_, _tmp13_);
			_tmp9_ = _tmp14_;
		} else {
			_tmp9_ = FALSE;
		}
		_tmp15_ = _tmp9_;
		if (_tmp15_) {
			WnckWindow* _tmp16_ = NULL;
			_tmp16_ = window;
			plank_services_windows_window_control_center_and_focus_window (_tmp16_);
			g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
		}
		_g_object_unref0 (window);
	}
	_tmp17_ = _data1_->targetWindow;
	plank_services_windows_window_control_center_and_focus_window (_tmp17_);
	_tmp18_ = additional_windows;
	_tmp19_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp18_);
	_tmp20_ = _tmp19_;
	if (_tmp20_ <= 1) {
		_g_object_unref0 (iterator);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		return;
	}
	_tmp21_ = gtk_get_current_event_time ();
	_data1_->time = _tmp21_ + PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY;
	gdk_threads_add_timeout (PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY, ___lambda2__gsource_func, _data1_);
	_g_object_unref0 (iterator);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


static gboolean plank_services_windows_window_control_windows_share_viewport (WnckWindow* first, WnckWindow* second) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	WnckWindow* _tmp1_ = NULL;
	gboolean _tmp3_ = FALSE;
	WnckWorkspace* _tmp4_ = NULL;
	WnckWindow* _tmp5_ = NULL;
	WnckWorkspace* _tmp6_ = NULL;
	WnckWorkspace* _tmp7_ = NULL;
	WnckWorkspace* _tmp8_ = NULL;
	WnckWorkspace* wksp = NULL;
	WnckWorkspace* _tmp12_ = NULL;
	WnckWorkspace* _tmp13_ = NULL;
	WnckWorkspace* _tmp14_ = NULL;
	GdkRectangle firstGeo = {0};
	GdkRectangle secondGeo = {0};
	WnckWindow* _tmp15_ = NULL;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	WnckWindow* _tmp20_ = NULL;
	gint _tmp21_ = 0;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	WnckWorkspace* _tmp26_ = NULL;
	gint _tmp27_ = 0;
	gint _tmp28_ = 0;
	WnckWorkspace* _tmp29_ = NULL;
	gint _tmp30_ = 0;
	gint _tmp31_ = 0;
	WnckWorkspace* _tmp32_ = NULL;
	gint _tmp33_ = 0;
	gint _tmp34_ = 0;
	WnckWorkspace* _tmp35_ = NULL;
	gint _tmp36_ = 0;
	gint viewportWidth = 0;
	WnckWindow* _tmp37_ = NULL;
	WnckScreen* _tmp38_ = NULL;
	gint _tmp39_ = 0;
	gint viewportHeight = 0;
	WnckWindow* _tmp40_ = NULL;
	WnckScreen* _tmp41_ = NULL;
	gint _tmp42_ = 0;
	gint firstViewportX = 0;
	GdkRectangle _tmp43_ = {0};
	gint _tmp44_ = 0;
	GdkRectangle _tmp45_ = {0};
	gint _tmp46_ = 0;
	gint _tmp47_ = 0;
	gint _tmp48_ = 0;
	gint firstViewportY = 0;
	GdkRectangle _tmp49_ = {0};
	gint _tmp50_ = 0;
	GdkRectangle _tmp51_ = {0};
	gint _tmp52_ = 0;
	gint _tmp53_ = 0;
	gint _tmp54_ = 0;
	GdkRectangle viewpRect = {0};
	gint _tmp55_ = 0;
	gint _tmp56_ = 0;
	gint _tmp57_ = 0;
	gint _tmp58_ = 0;
	GdkRectangle _tmp59_ = {0};
	gboolean _tmp60_ = FALSE;
	_tmp1_ = first;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		WnckWindow* _tmp2_ = NULL;
		_tmp2_ = second;
		_tmp0_ = _tmp2_ == NULL;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		result = FALSE;
		return result;
	}
	_tmp5_ = first;
	_tmp6_ = wnck_window_get_workspace (_tmp5_);
	_tmp7_ = _g_object_ref0 (_tmp6_);
	_tmp4_ = _tmp7_;
	_tmp8_ = _tmp4_;
	if (_tmp8_ == NULL) {
		WnckWindow* _tmp9_ = NULL;
		WnckWorkspace* _tmp10_ = NULL;
		WnckWorkspace* _tmp11_ = NULL;
		_tmp9_ = second;
		_tmp10_ = wnck_window_get_workspace (_tmp9_);
		_tmp11_ = _g_object_ref0 (_tmp10_);
		_g_object_unref0 (_tmp4_);
		_tmp4_ = _tmp11_;
	}
	_tmp12_ = _tmp4_;
	_tmp13_ = _g_object_ref0 (_tmp12_);
	wksp = _tmp13_;
	_tmp14_ = wksp;
	if (_tmp14_ == NULL) {
		result = FALSE;
		_g_object_unref0 (wksp);
		_g_object_unref0 (_tmp4_);
		return result;
	}
	memset (&firstGeo, 0, sizeof (GdkRectangle));
	memset (&secondGeo, 0, sizeof (GdkRectangle));
	_tmp15_ = first;
	wnck_window_get_geometry (_tmp15_, &_tmp16_, &_tmp17_, &_tmp18_, &_tmp19_);
	firstGeo.x = _tmp16_;
	firstGeo.y = _tmp17_;
	firstGeo.width = _tmp18_;
	firstGeo.height = _tmp19_;
	_tmp20_ = second;
	wnck_window_get_geometry (_tmp20_, &_tmp21_, &_tmp22_, &_tmp23_, &_tmp24_);
	secondGeo.x = _tmp21_;
	secondGeo.y = _tmp22_;
	secondGeo.width = _tmp23_;
	secondGeo.height = _tmp24_;
	_tmp25_ = firstGeo.x;
	_tmp26_ = wksp;
	_tmp27_ = wnck_workspace_get_viewport_x (_tmp26_);
	firstGeo.x = _tmp25_ + _tmp27_;
	_tmp28_ = firstGeo.y;
	_tmp29_ = wksp;
	_tmp30_ = wnck_workspace_get_viewport_y (_tmp29_);
	firstGeo.y = _tmp28_ + _tmp30_;
	_tmp31_ = secondGeo.x;
	_tmp32_ = wksp;
	_tmp33_ = wnck_workspace_get_viewport_x (_tmp32_);
	secondGeo.x = _tmp31_ + _tmp33_;
	_tmp34_ = secondGeo.y;
	_tmp35_ = wksp;
	_tmp36_ = wnck_workspace_get_viewport_y (_tmp35_);
	secondGeo.y = _tmp34_ + _tmp36_;
	_tmp37_ = first;
	_tmp38_ = wnck_window_get_screen (_tmp37_);
	_tmp39_ = wnck_screen_get_width (_tmp38_);
	viewportWidth = _tmp39_;
	_tmp40_ = first;
	_tmp41_ = wnck_window_get_screen (_tmp40_);
	_tmp42_ = wnck_screen_get_height (_tmp41_);
	viewportHeight = _tmp42_;
	_tmp43_ = firstGeo;
	_tmp44_ = _tmp43_.x;
	_tmp45_ = firstGeo;
	_tmp46_ = _tmp45_.width;
	_tmp47_ = viewportWidth;
	_tmp48_ = viewportWidth;
	firstViewportX = ((_tmp44_ + (_tmp46_ / 2)) / _tmp47_) * _tmp48_;
	_tmp49_ = firstGeo;
	_tmp50_ = _tmp49_.y;
	_tmp51_ = firstGeo;
	_tmp52_ = _tmp51_.height;
	_tmp53_ = viewportHeight;
	_tmp54_ = viewportHeight;
	firstViewportY = ((_tmp50_ + (_tmp52_ / 2)) / _tmp53_) * _tmp54_;
	memset (&viewpRect, 0, sizeof (GdkRectangle));
	_tmp55_ = firstViewportX;
	viewpRect.x = _tmp55_;
	_tmp56_ = firstViewportY;
	viewpRect.y = _tmp56_;
	_tmp57_ = viewportWidth;
	viewpRect.width = _tmp57_;
	_tmp58_ = viewportHeight;
	viewpRect.height = _tmp58_;
	_tmp59_ = secondGeo;
	_tmp60_ = gdk_rectangle_intersect (&viewpRect, &_tmp59_, NULL);
	result = _tmp60_;
	_g_object_unref0 (wksp);
	_g_object_unref0 (_tmp4_);
	return result;
}


static void plank_services_windows_window_control_center_and_focus_window (WnckWindow* w) {
	guint32 time = 0U;
	guint32 _tmp0_ = 0U;
	gboolean _tmp1_ = FALSE;
	WnckWindow* _tmp2_ = NULL;
	WnckWorkspace* _tmp3_ = NULL;
	gboolean _tmp9_ = FALSE;
	WnckWindow* _tmp13_ = NULL;
	gboolean _tmp14_ = FALSE;
	WnckWindow* _tmp17_ = NULL;
	guint32 _tmp18_ = 0U;
	g_return_if_fail (w != NULL);
	_tmp0_ = gtk_get_current_event_time ();
	time = _tmp0_;
	_tmp2_ = w;
	_tmp3_ = wnck_window_get_workspace (_tmp2_);
	if (_tmp3_ != NULL) {
		WnckWindow* _tmp4_ = NULL;
		WnckWorkspace* _tmp5_ = NULL;
		WnckWindow* _tmp6_ = NULL;
		WnckScreen* _tmp7_ = NULL;
		WnckWorkspace* _tmp8_ = NULL;
		_tmp4_ = w;
		_tmp5_ = wnck_window_get_workspace (_tmp4_);
		_tmp6_ = w;
		_tmp7_ = wnck_window_get_screen (_tmp6_);
		_tmp8_ = wnck_screen_get_active_workspace (_tmp7_);
		_tmp1_ = _tmp5_ != _tmp8_;
	} else {
		_tmp1_ = FALSE;
	}
	_tmp9_ = _tmp1_;
	if (_tmp9_) {
		WnckWindow* _tmp10_ = NULL;
		WnckWorkspace* _tmp11_ = NULL;
		guint32 _tmp12_ = 0U;
		_tmp10_ = w;
		_tmp11_ = wnck_window_get_workspace (_tmp10_);
		_tmp12_ = time;
		wnck_workspace_activate (_tmp11_, _tmp12_);
	}
	_tmp13_ = w;
	_tmp14_ = wnck_window_is_minimized (_tmp13_);
	if (_tmp14_) {
		WnckWindow* _tmp15_ = NULL;
		guint32 _tmp16_ = 0U;
		_tmp15_ = w;
		_tmp16_ = time;
		wnck_window_unminimize (_tmp15_, _tmp16_);
	}
	_tmp17_ = w;
	_tmp18_ = time;
	wnck_window_activate_transient (_tmp17_, _tmp18_);
}


void plank_services_windows_window_control_get_easy_geometry (WnckWindow* w, GdkRectangle* result) {
	GdkRectangle geo = {0};
	WnckWindow* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	g_return_if_fail (w != NULL);
	memset (&geo, 0, sizeof (GdkRectangle));
	_tmp0_ = w;
	wnck_window_get_geometry (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
	geo.x = _tmp1_;
	geo.y = _tmp2_;
	geo.width = _tmp3_;
	geo.height = _tmp4_;
	*result = geo;
	return;
}


static void plank_services_windows_window_control_class_init (PlankServicesWindowsWindowControlClass * klass) {
	plank_services_windows_window_control_parent_class = g_type_class_peek_parent (klass);
}


static void plank_services_windows_window_control_instance_init (PlankServicesWindowsWindowControl * self) {
}


GType plank_services_windows_window_control_get_type (void) {
	static volatile gsize plank_services_windows_window_control_type_id__volatile = 0;
	if (g_once_init_enter (&plank_services_windows_window_control_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankServicesWindowsWindowControlClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_services_windows_window_control_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankServicesWindowsWindowControl), 0, (GInstanceInitFunc) plank_services_windows_window_control_instance_init, NULL };
		GType plank_services_windows_window_control_type_id;
		plank_services_windows_window_control_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankServicesWindowsWindowControl", &g_define_type_info, 0);
		g_once_init_leave (&plank_services_windows_window_control_type_id__volatile, plank_services_windows_window_control_type_id);
	}
	return plank_services_windows_window_control_type_id__volatile;
}



